#include <stdio.h>
#include <stdlib.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Intrinsic.h>

/* 
 * "-misc-fixed-medium-r-normal--14-*-*-*-*-*-jisx0208.1983-0"
 *----
 * "jisx0208.1983-0" ãޤǤо줷 "-" ο
 */
#define BAR_NO_KAZU	(13)

/*
 * skkinput ɬפȤƤեȤ̾ġ
 */
/*  kanji_font Ȥƽİ˰äƤΤ롣*/
static unsigned char *skkinputs_kanji_fonts[] =
{ "jisx0208.1983-0", "jisx0208.1990-0", NULL } ;
/*  roman_font Ȥƽİ˰äƤΤ롣*/
static unsigned char *skkinputs_roman_fonts[] =
{ "iso8859-1", "jisx0201.1976-0", NULL } ;

struct skkinput_font_list {
  XFontStruct	*font ;			/* եȡ*/
  int		refer_count ;		/* ȤƤ*/
  char		*name ;			/* ̾*/
  struct skkinput_font_list	*next ;
} ;

/*
 * եȴꥹȡ
 */
struct skkinput_font_list *fontlist_top = NULL ;

/*
 *
 */
static struct skkinput_font_list *alloc_fontlist_node( void )
{
  struct skkinput_font_list *node ;

  node = ( struct skkinput_font_list *)malloc
    ( sizeof( struct skkinput_font_list ) ) ;
  /* ա֤ꤵ󡢤ɤޤ礦꤬ʤʤäƤޤޤġ*/
  /* ֤ʤ衢աġäơϤɤ褦ʤ */
  if( node == NULL ){
    fprintf( stderr, "Memory fault ....\n" ) ;
    exit( 1 ) ;
  }
  /* ȽƤ*/
  node->next = NULL ;
  node->name = NULL ;
  node->font = NULL ;
  node->refer_count = 0 ;
  return node ;
}

/*
 * ˥եȤϿƤ뤫ɤåؿ
 */
static struct skkinput_font_list *find_font_by_name
( unsigned char *name )
{
  struct skkinput_font_list *node = fontlist_top ;

  /* ꥹȤƬ NULL ä顢ꥹȼΤǤ*/
  if( node == NULL )
    return NULL ;
  /* 硹˥ꥹȤ򤿤ɤޤ礦͡ */
  while( node != NULL ){
    if( !strcmp( node->name, name ) )
      return node ;
    node = node->next ;
  }
  /* դޤǤ͡*/
  return NULL ;
}

/*
 * ȤʤʤäեȤ뤿Ѥؿ
 */
static void free_fontlist_node
( Display *disp, XFontStruct *font )
{
  struct skkinput_font_list *node, *pNode ;

  pNode = node = fontlist_top ;
  while( node != NULL ){
    /* ʤݥ󥿤Ӥơ¸ߤƤեȤɤƤ */
    /* 롣*/
    if( node->font == font ){
      break ;
    }
    pNode = node ;
    node  = node->next ;
  }
  /* Τ褦ʥեȤ¸ߤޤ󤳤Ȥ衣ۤۤۤۡ(äƲԡ)*/
  if( node == NULL )
    return ;

  if( node->refer_count > 1 ){
    /* ¾ˤ⻲ȤƤͤΤǡõǤʤ*/
    node->refer_count -- ;
    return ;
  }
  /* ⤦ȤƤͤϼʬʤΤǡõƤޤ*/

  /* ޤեȤơ*/
  XFreeFont( disp, node->font ) ;
  /* եȤ̾롣*/
  free( node->name ) ;

  /* ꥹȤΡɤϤ*/
  if( pNode == node ){
    fontlist_top = node->next ;
  } else {
    pNode->next = node->next ;
  }
  /* ΡɼΤ롣*/
  free( node ) ;
  return ;
}

/*
 * եȤؿ
 */
static XFontStruct *add_new_font( Display *disp, unsigned char *name )
{
  struct skkinput_font_list *node ;

  /* ¸ߤƤ뤫ɤǧ롣*/
  if( ( node = find_font_by_name( name ) ) == NULL ){
    /* ¸ߤƤʤä顢ݤ롣*/
    node = alloc_fontlist_node() ;
    /* ꥹȤˤĤʤ*/
    node->next   = fontlist_top ;
    fontlist_top = node ;
    /* եȤɤ߹ࡣ*/
    node->font   = XLoadQueryFont( disp, name ) ;
    /* եȤ̾ϿƤ*/
    node->name   = malloc( strlen( name ) + 1 ) ;
    strcpy( node->name, name ) ;
    /* ʬȤƤʤ顢Ȥ 1 Ǥ롣*/
    node->refer_count = 1 ;
  } else {
    /* ¸ߤƤΤʤ顢ȥȤ 1 䤷Ƥ*/
    node->refer_count ++ ;
  }
  return ( node->font ) ;
}

/*
 * եȤ̾ǧؿ
 *----
 * skkinput ɬפʥեȤɤåؿƽФ
 * Ȥˤʤ롣
 */
static int is_match_font_name
( char *font_name, char *type_name )
{
  int bar_counter, chara ;
  
  for( bar_counter = 0 ; bar_counter < BAR_NO_KAZU ; bar_counter ++ ){
    /* "-"  "-" δ֤ˤʸʤ*/
    while( *font_name != '-' ){
      /* ȾФˤơƤޤä False */
      if( *font_name == '\0' )
	return False ;
      font_name ++ ;
    }
    /* ߤθƤ֤ˤ "-" 򥹥åפ롣*/
    font_name ++ ;
  }
  while( *font_name != '\0' ){
    chara = ( *font_name >= 'A' && *font_name <= 'Z' )?
      ( *font_name + ( 'a' - 'A' ) ) : *font_name ;
    if( chara != *type_name )
      return False ;
    font_name ++ ;
    type_name ++ ;
  }
  if( *type_name == '\0' )
    return True ;
  return False ;
}

/*
 * skkinput ѤեȤǤ뤫ɤȽ̤ؿ
 * ---
 * "jisx0208.1983-0", "iso8859-1", "jisx0201.1976-0" 
 */
static int is_skkinputs_font
( unsigned char **font_types, unsigned char *name )
{
  while( *font_types != NULL ){
    /* 礨СTrue ֤*/
    if ( is_match_font_name( name, *font_types ) )
      return True ;
    font_types ++ ;
  }
  return False ;
}

static void my_xload_font
( Display *disp, unsigned char *font_name,
  XFontStruct *skkinput_fontset[ 2 ],
  int *def_kanji_font, int *def_roman_font )
{
  /* skkinput ѤƤեȤλǤ */
  if( is_skkinputs_font( skkinputs_kanji_fonts, font_name ) &&
     !( *def_kanji_font ) ){
    /* ϿɤΥե饰 True ˤƤ*/
    *def_kanji_font = True ;
    skkinput_fontset[ 1 ] = add_new_font( disp, font_name ) ;
  }
  /* skkinput ѤƤѻեȤλǤ */
  if( is_skkinputs_font( skkinputs_roman_fonts, font_name ) &&
     !( *def_roman_font ) ){
    /* ϿɤΥե饰 True ˤƤ*/
    *def_roman_font = True ;
    skkinput_fontset[ 0 ] = add_new_font( disp, font_name ) ;
  }
  return ;
}

/*
 *  2 äƤΤʿɡĤäѤ #define Ȥʡ
 */
int prepare_font_from_atom
( Display *disp, XFontStruct *skkinput_fontset[ 2 ],
  Atom *fontatoms, Cardinal num_of_fonts )
{
  int i, def_kanji_font, def_roman_font ;
  Atom *aptr ;
  unsigned char *name ;

  def_kanji_font = def_roman_font = False ;

  /* 褿եȤ󤿤ͤĥå롣*/
  for( i = 0, aptr = fontatoms ; i < num_of_fonts ; i ++, aptr ++ ){
    /* ޤեȤ̾ȴФ*/
    if( ( name = XGetAtomName( disp, *aptr ) ) == NULL )
      continue ;
    /* եȤɤ߹ࡣ*/
    my_xload_font
      ( disp, name, skkinput_fontset,
        &def_kanji_font, &def_roman_font ) ;
#if defined(DEBUG)
    fprintf( stderr, "Prepare Font From Atom: %s (rom:%d,kan:%d)\n", name,
	     def_roman_font, def_kanji_font ) ;
#endif
    /* XGetAtomName  malloc 㤦ͤʤΤǡfree ʤܡ*/
    free( name ) ;
  }
  return True ;
}

/*
 * ѴλѤƤեȤ뤿Ѥؿ
 */
int close_fonts_of_skkinput
( Display *disp, XFontStruct *skkinput_fonts[ 2 ] )
{
  int i ;
  /* եȤϿƤΤäˤƤ*/
  for( i = 0 ; i < 2 ; i ++ ){
    if( skkinput_fonts[ i ] != NULL )
      free_fontlist_node( disp, skkinput_fonts[ i ] ) ;
  }
  return True ;
}

/*
 * եȤ롣
 */
int close_one_font_of_skkinput
( Display *disp, XFontStruct *font )
{
  if( font == NULL )
    return False ;
  free_fontlist_node( disp, font ) ;
  return True ;
}

/*
 * եȤ̾Υꥹ(ѥ졼 ",")եȤ̾ȴ
 * ơбեȤѰդؿ
 */
int prepare_font_from_name
( Display *disp, XFontStruct *skkinput_fontset[ 2 ], char *font_name_list )
{
  int def_kanji_font, def_roman_font ;
  char *ptr, *font_name ;

#if defined(DEBUG)
  fprintf( stderr, "(Prepare) Font Set : %s\n", font_name_list ) ;
#endif
  font_name = font_name_list ;
  def_kanji_font = def_roman_font = 0 ;
  for( ptr = font_name_list ; *ptr != '\0' ; ptr ++ ){
    /* ʸǤ */
    if( *ptr != ',' )
      continue ;

    /* ʸĤ֤*/
    *ptr = '\0' ;
    /* եȤɤ߹ࡣ*/
    my_xload_font
      ( disp, font_name, skkinput_fontset, 
        &def_kanji_font, &def_roman_font ) ;
    *ptr = ',' ;
    /* ʸľƤ*/
    font_name = ptr + 1 ;
  }
  /* ʸ̵ʤʸκǸޤ褿硣*/
  if( font_name_list == font_name ){
    /* եȤɤ߹ࡣ*/
    my_xload_font
      ( disp, font_name, skkinput_fontset,
        &def_kanji_font, &def_roman_font ) ;
  }
  return ( def_kanji_font + def_roman_font ) ;
}

#if 0
/*
 * 괺ΥƥѤΥɤǤ
 */
int fontset_test
( Display *disp, Atom *fontatoms, Cardinal num_of_fonts )
{
  int i ;
  Atom *aptr ;
  unsigned char *name ;

  for( i = 0, aptr = fontatoms ; i < num_of_fonts ; i ++, aptr ++ ){
    name = XGetAtomName( disp, *aptr ) ;
    fprintf
      ( stderr, "Font Name is \"%s\n\".\n", name ) ;
    free( name ) ;
  }
  return 0 ;
}
#endif
