#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <X11/Xlib.h>
#include <X11/IntrinsicP.h>

#include "commondef.h"
#include "HistMgr.h"
#include "resrcs.h"

extern int  IsWindowExist( Display *disp, Window win ) ;

static HistoryListNode *unmanagedHistoryListTop = NULL ;

/*
 * ΥΥץ饤١Ȥʴؿã
 */
static HistoryListNode *create_newHistoryNode( Window client )
{
  HistoryListNode *node ;
  /* malloc Ѥƥݤ롣*/
  if( ( node = malloc( sizeof( HistoryListNode ) ) ) == NULL ){
    /* ϤݤǤʤä硣*/
    fprintf( stderr, "Memory fault...\n" ) ;
    exit( 1 ) ;
  }
  /* ǰΤˤ餫ƤʤƤɬפʻ˾ */
  /* ˽ĤǤϤΤġ*/
  node->mask          = 0 ;
  node->next          = NULL ;
  node->client        = client ;
  node->history_start = node->history_end = 0 ;
  node->history[ 0 ]  = '\0' ;
  return node ;
}

static void history_discard( Display *disp )
{
  HistoryListNode *node = unmanagedHistoryListTop, *pNode ;
  pNode = node ;
  while( node != NULL ){
    /* 饤ȥɥ¸ߤ뤫ɤĴ٤롣*/
    if( !IsWindowExist( disp, node->client ) ){
      /* ¸ߤʤʤäƤΤʤ顢ҥȥä롣*/
      if( node == pNode ){
	unmanagedHistoryListTop = node->next ;
	free( node ) ;
	pNode = node = unmanagedHistoryListTop ;
      } else {
	pNode->next = node->next ;
	free( node ) ;
	node = pNode->next ;
      }
    } else {
      pNode = node ;
      node = node->next ;
    }
  }
  return ;
}

/*
 * Υγ黲Ȥѥ֥åʴؿã
 */

void history_setup( Widget gw, Window client_window )
{
  HistoryListNode *node, *pNode ;

  pNode = node = unmanagedHistoryListTop ;
  while( node != NULL ){
    if( node->client == client_window )
      break ;
    pNode = node ;
    node  = node->next ;
  }
  if( node == NULL ){
    node = create_newHistoryNode( client_window ) ;
    node->mask = HISTORY_BUFFER_MASK ;
  } else {
    if( pNode == node ){
      unmanagedHistoryListTop = node->next ;
    } else {
      pNode->next = node->next ;
    }
  }
  XtVaSetValues( gw, XtNconversionHistory, node, NULL ) ;
  return ;
}

void history_close( Display *disp, caddr_t caller )
{
  HistoryListNode *node = ( HistoryListNode *)caller ;

  node->next = unmanagedHistoryListTop ;
  unmanagedHistoryListTop = node ;
  node->mask |= ( HISTORY_SIZE_MASK | HISTORY_POSITION_MASK ) ;
  /* ǼºߤФƤʤΤɾ*/
  history_discard( disp ) ;
  return ;
}
