#include <stdio.h>
#include <X11/Xlib.h>

static int error_occured ;
static int error_type ;
static int ignore_flag ;

/*
 * 顼ǽؿ
 */
static int my_errorhandler
( Display *disp, XErrorEvent *xee )
{
  /* 顼ȴФ*/
  error_occured = True ;
  error_type    = xee->error_code ;
  return 0 ;
}

/*
 * 顼ǽؿ
 */
static int normal_errorhandler
( Display *disp, XErrorEvent *xee )
{
  /* 顼ȴФ*/
  error_occured = True ;
  fprintf( stderr, "XError Event is recieved.\n" ) ;
  fprintf( stderr, "serial        = %ld\n", xee->serial ) ;
  fprintf( stderr, "error_code    = %d\n",  xee->error_code ) ;
  fprintf( stderr, "request_code  = %d\n",  xee->request_code ) ;
  fprintf( stderr, "minor_code    = %d\n",  xee->minor_code ) ;
  fprintf( stderr, "resource_id   = %ld\n", xee->resourceid ) ;
  fprintf( stderr, "any.window    = %lu\n", ( ( XEvent * )xee )->xany.window ) ;
#if defined(DEBUG)
  while( 1 ) ;
#else
  exit ( 1 ) ;
#endif
}


void ignore_xerror( void )
{
  error_occured = False ;
  ignore_flag   = True ;
  XSetErrorHandler( my_errorhandler ) ;
  return ;
}

void regard_xerror( void )
{
  error_occured = False ;
  ignore_flag   = False ;
  XSetErrorHandler( normal_errorhandler ) ;
  return ;
}

void initialize_myerrorhandler( void )
{
  error_type = 0 ;
  regard_xerror() ;
  return ;
}

/*
 * ºݤ˥ɥ¸ߤ뤫ɤǧ뤿Ѥؿ
 */
int  IsWindowExist( Display *disp, Window win )
{
  XWindowAttributes xwa ;
  int errorflag ;

  if( ignore_flag ){
    error_occured = False ;
    XGetWindowAttributes
      ( disp, win, &xwa ) ;
    errorflag = error_occured ;
  } else {
    ignore_xerror() ;
    XGetWindowAttributes
      ( disp, win, &xwa ) ;
    errorflag = error_occured ;
    regard_xerror() ;
  }
  return ( !errorflag ) ;
}

/*
 * ºݤ˥ɥ¸ߤ뤫ɤǧ뤿Ѥؿ
 */
int  isWindowExistIfExistsGetXWA
( Display *disp, Window win, XWindowAttributes *xwa )
{
  int errorflag ;

  if( ignore_flag ){
    error_occured = False ;
    XGetWindowAttributes
      ( disp, win, xwa ) ;
    errorflag = error_occured ;
  } else {
    ignore_xerror() ;
    XGetWindowAttributes
      ( disp, win, xwa ) ;
    errorflag = error_occured ;
    regard_xerror() ;
  }
  return ( !errorflag ) ;
}

int xerror_occured( void )
{
  return error_occured ;
}
