/* # skkinput (Simple Kana-Kanji Input)
 * SkkInput.c --- Making OverTheSpotWinWidget.
 * This file is part of skkinput.
 * Copyright (C) 1997
 * Takashi SAKAMOTO (sakamoto@yajima.kuis.kyoto-u.ac.jp)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with skkinput; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <X11/Xos.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/keysym.h>
#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>

#include "OffWinP.h"
#include "config.h"
#include "skkkey.h"
#include "otwexfunc.h"
#include "SubwindowShell.h"
#include "Canvas.h"
#include "WmcloseShell.h"

#ifndef XtNgeometry
#define XtNgeometry		"geometry"
#define XtCGeometry		"Geometry"
#endif

#define offset(field) XtOffsetOf( OffthespotWinRec, offthespotWin.field)
#define goffset(field) XtOffsetOf( WidgetRec, core.field )

static XtResource OFFW_resources[] = {
  /* Ȥ餢꥽*/
  { XtNwidth, XtCWidth, XtRDimension, sizeof(Dimension),
    goffset(width), XtRImmediate, (XtPointer) 400},
  { XtNheight, XtCHeight, XtRDimension, sizeof(Dimension),
    goffset(height), XtRImmediate, (XtPointer) 400},
  /* ߥ˥Хåե礭ꤹġǥեȤΤ͡١ꥵ *
   * Ф褦ˤ褦 */
  { XtNmwidth, XtCMwidth, XtRDimension, sizeof(Dimension),
    offset(minibuf_width), XtRImmediate, (XtPointer)80 },
  /* ʬȤǺä꥽*/
  { XtNforeground, XtCForeground, XtRPixel, sizeof(Pixel),
    offset(puppixel), XtRString, XtDefaultForeground },
  /* Minibuffer ȿžɽ뤫ɤȤäˤʤ롣*/
  { XtNreverseVideo, XtCReverseVideo, XtRBoolean, sizeof (Boolean),
    offset(reverse_video), XtRImmediate, (XtPointer) FALSE},
  /* Overthespot Ѥեȵڤӥ޻եȡ*/
  { XtNfont, XtCFont, XtRFontStruct, sizeof(XFontStruct *),
    offset(fs_default_roman), XtRString, DEFAULT_ROMANFONT },
  { XtNkanjiFont, XtCFont, XtRFontStruct, sizeof(XFontStruct *),
    offset(fs_default_kanji), XtRString, DEFAULT_KANJIFONT },
  /* Minibuffer Window 褹ΤѤڤӥ޻եȡ*/
  { XtNmfont, XtCFont, XtRFontStruct, sizeof(XFontStruct *),
    offset(fs_minibuf_roman), XtRString, DEFAULT_ROMANFONT },
  { XtNmkanjiFont, XtCFont, XtRFontStruct, sizeof(XFontStruct *),
    offset(fs_minibuf_kanji), XtRString, DEFAULT_KANJIFONT },
  /* Minibuffer Window 礭եȤν˺뤫ɤ*/
  { XtNchangeMinibufferFont, XtCChangeMinibufferFont,
    XtRBoolean, sizeof ( Boolean ),
    offset(change_minibuffer_font), XtRImmediate, (XtPointer)TRUE },
  /* skkinput 뤬ĤѤ callback */
  { XtNendNotify, XtCCallback, XtRCallback, sizeof(caddr_t), 
    offset(endcallback), XtRCallback, (caddr_t)NULL },
  /* skkinput  client ʸѤ callback */
  { XtNfixNotify, XtCCallback, XtRCallback, sizeof(caddr_t), 
    offset(fixcallback), XtRCallback, (caddr_t)NULL },
  /* key event  client ֤Ѥ callback */
  { XtNkeybackNotify, XtCCallback, XtRCallback, sizeof(caddr_t), 
    offset(keybackcallback), XtRCallback, (caddr_t)NULL },
  /* egg ߴ j-newline ݤ*/
  { XtNeggLikeNewline, XtCEggLikeNewline, XtRImmediate, sizeof (int),
    offset(egg_like_newline), XtRImmediate, (XtPointer) FALSE},
  /* chat-adapter-mode ݤ*/
  { XtNchatAdapter, XtCChatAdapter, XtRImmediate, sizeof (int),
    offset(chat_adapter), XtRImmediate, (XtPointer) FALSE},
  { XtNjisyoDirty, XtCJisyoDirty, XtRImmediate, sizeof (int),
    offset(jisyo_dirty), XtRImmediate, (XtPointer) FALSE },
  { XtNconversionAttribute, XtCConversionAttribute, XtRImmediate, 
    sizeof( struct ConvAttrsMesg * ),
    offset( camsg ), XtRImmediate, ( XtPointer )NULL },
  /* ߥ˥Хåեξõ롣*/
  { XtNclearMinibuffer, XtCClearMinibuffer, XtRImmediate, sizeof( int ),
    offset( clearMinibuffer ), XtRImmediate, (XtPointer)FALSE },
  { XtNclientWindow, XtCClientWindow, XtRImmediate, sizeof( Window ),
    offset( client_window ), XtRImmediate, (XtPointer)None },
  { XtNsetFocus, XtCSetFocus, XtRImmediate, sizeof( int ),
    offset( conversion_set_focus ), XtRImmediate, (XtPointer)FALSE },
  { XtNunsetFocus, XtCUnsetFocus, XtRImmediate, sizeof( int ),
    offset( conversion_unset_focus ), XtRImmediate, (XtPointer)FALSE },
  /* Subwindow ե֤ɥꤹ롣*/
  { XtNprobeWindow, XtCProbeWindow, XtRImmediate, sizeof( Window ),
    offset( probe_window ), XtRImmediate, ( XtPointer )None },
} ;

#undef offset
#undef goffset

/*
 * ץȥ
 */
/*
 * ΥåȤƤǤȤʤؿ
 */
static void OFFW_Initialize
( Widget greq, Widget gnew, ArgList args, Cardinal *num_args ) ;
static void OFFW_Realize
( Widget gw, XtValueMask *valueMask, XSetWindowAttributes *attrs ) ;
static void OFFW_Redisplay
( Widget gw, XEvent *event, Region region ) ;
static void OFFW_Destroy( Widget gw ) ;
static Boolean OFFW_SetValues
( Widget current, Widget request, Widget new,
  ArgList args, Cardinal *num_args ) ;
static void KeyDownEventHandler
( Widget w, XEvent *event, String *params, Cardinal *num_params ) ;
static void FocusEventHandler
( Widget gw, XEvent *xevent, String *params, Cardinal *num_params ) ;

static void OFFW_CreateAllGCs( Widget gw ) ;
static void OFFW_CreateMinibufferGCs( Widget gw ) ;
static void OFFW_ReleaseAllGCs( Widget gw ) ;
static void OFFW_ReleaseMinibufferGCs( Widget gw ) ;

static int OFFW_ChangeAttributes
( Widget gw, unsigned long valuemask, struct ConvAttrs *values ) ;
static void OFFW_resetupModeWindow( Widget gw ) ;
static void OFFW_ReconfigureColor
( Widget gw, unsigned long valuemask ) ;

static void OFFW_ConfigureMinibuffer( Widget gw ) ;

static int do_function_by_reading_character
( Widget gw, struct SKKInputNode *node ) ;
static void OFFW_RedrawScreen( Widget gw ) ;
static int OFFW_ReconfigureFocusPosition
( Widget gw ) ;

static int focusCheck( Widget gw ) ;
/*
 * callbacks
 */
static void Canvas_RedisplayCallback
( Widget gw, caddr_t client, caddr_t caller ) ;
static void Minibuffer_RedisplayCallback
( Widget gw, caddr_t client, caddr_t caller ) ;
static void Modeshell_RedisplayCallback
( Widget gw, caddr_t client, caddr_t caller ) ;
static void Canvas_DestroyCallback
( Widget gw, caddr_t client, caddr_t caller ) ;
static void OFFW_wmMessageCloseCallback
( Widget gw, caddr_t client, caddr_t caller ) ;
static void OFFW_wmShellDestroyCallback
( Widget gw, caddr_t client, caddr_t caller ) ;

/*
 * Window ˴ؤؿΥץȥ 
 */
extern void skkwin_jputstring
( Display *disp, Window win, GC roman_gc, GC kanji_gc,
  int x, int y, char *text, int roman_width, int kanji_width ) ;
extern void skkwin_jputchar
( Display *disp, Window win, GC roman_gc, GC kanji_gc,
  int x, int y, int chara, int flag ) ;
extern void skkinputDrawCursor
( Display *disp, Window win, GC roman_ngc, GC roman_rgc, 
  int x, int y, int font_ascent, int width, int height,
  int is_focus ) ;
extern GC my_CreateGC
( Widget gw, Pixel foreground, Pixel background, XFontStruct *font ) ;
extern void getFontInfo
( XFontStruct *fs_kanji, XFontStruct *fs_roman,
  int *ret_kanji_width, int *ret_roman_width,
  int *ret_font_height, int *ret_font_ascent ) ;
extern void OTSW_CalcTopPositionOfBuffer
( unsigned char *linetop, int linetop_pos, int cur_pos,
  int client_width, int roman_width, int kanji_width,
  unsigned char **ret_toptext, int *ret_toppos ) ;
extern void OTSW_FullDrawTopBufferTopLine
( Display *disp, Window win,
  GC roman_ngc, GC kanji_ngc, GC roman_rgc, GC kanji_rgc,
  unsigned char *text, int text_pos,
  int roman_width, int kanji_width, int font_ascent, int font_height,
  int width, int bsflag, int cur_pos, int cur_exist, int is_focus ) ;
extern int skkinput_GetLineNum
( unsigned char *text, int roman_width, int kanji_width,
  unsigned int width, int cur_pos, int *cur_line ) ;
extern int skkinput_FindStartLine
( unsigned char *text, int roman_width, int kanji_width,
  int startline, unsigned int width ) ;
extern void XChangeWMNormalHints
( Display *disp, Window win, XSizeHints *hints ) ;
extern void XGetRectangleOfWindow
( Display *disp, Window win, XRectangle *area ) ;

/* MyDispatch.c */
extern int add_myeventhandler
( Display *disp, Window src_win, Window dest_win,
  int event_type, long event_mask ) ;
extern int remove_allmyeventhandler
( Display *disp, Window src_win ) ;

/* MyError.c */
extern void ignore_xerror( void ) ;
extern void regard_xerror( void ) ;

/*
 * Хѿ
 */
static XtActionsRec offthespotWinActionsTable [] = {
  { "KeyDownEventHandler",	   KeyDownEventHandler },
  { "FocusInEventHandler",	   FocusEventHandler },
  { "FocusOutEventHandler",	   FocusEventHandler },
};

static char defaultOffthespotWinTranslations[] =  
"<Key>:                   KeyDownEventHandler()\n\
 <FocusIn>:               FocusInEventHandler()\n\
 <FocusOut>:              FocusOutEventHandler()\n" ;

OffthespotWinClassRec offthespotWinClassRec = {
    { /* core fields */
    /* superclass		*/	&widgetClassRec,
    /* class_name		*/	"Offthespot",
    /* size			*/	sizeof( OffthespotWinRec ),
    /* class_initialize		*/	NULL,
    /* class_part_initialize	*/	NULL,
    /* class_inited		*/	FALSE,
    /* initialize		*/	OFFW_Initialize,
    /* initialize_hook		*/	NULL,
    /* realize			*/	OFFW_Realize,
    /* actions			*/	offthespotWinActionsTable,
    /* num_actions		*/	XtNumber( offthespotWinActionsTable ),
    /* resources		*/	OFFW_resources,
    /* num_resources		*/	XtNumber( OFFW_resources ),
    /* xrm_class		*/	NULLQUARK,
    /* compress_motion		*/	TRUE,
    /* compress_exposure	*/	TRUE,
    /* compress_enterleave	*/	TRUE,
    /* visible_interest		*/	FALSE,
    /* destroy			*/	OFFW_Destroy,
    /* resize			*/	NULL,
    /* expose			*/	OFFW_Redisplay,
    /* set_values		*/	OFFW_SetValues,
    /* set_values_hook		*/	NULL,
    /* set_values_almost	*/	XtInheritSetValuesAlmost,
    /* get_values_hook		*/	NULL,
    /* accept_focus		*/	NULL,
    /* version			*/	XtVersion,
    /* callback_private		*/	NULL,
    /* tm_table			*/	defaultOffthespotWinTranslations,
    /* query_geometry		*/	XtInheritQueryGeometry,
    }
};

WidgetClass offthespotWinWidgetClass =
( WidgetClass )&offthespotWinClassRec ;

static void OFFW_Initialize 
( Widget greq, Widget gnew, ArgList args, Cardinal *num_args )
{
  OffthespotWinWidget w = ( OffthespotWinWidget )gnew ;
  struct SKKInputNode *node ;
  
  /* ե٥åɽΤ GC 롣*/
  w->offthespotWin.background = w->core.background_pixel ;
  w->offthespotWin.foreground = w->offthespotWin.puppixel ;
  w->offthespotWin.colormap   = w->core.colormap ;
  w->offthespotWin.oforeground = w->offthespotWin.foreground ;
  w->offthespotWin.obackground = w->offthespotWin.background ;

  /* ǥեȤΥեȤˤƤ*/
  w->offthespotWin.fs_roman = w->offthespotWin.fs_default_roman ;
  w->offthespotWin.fs_kanji = w->offthespotWin.fs_default_kanji ;

  /* եȤξȴФƤ*/
  getFontInfo
    ( w->offthespotWin.fs_kanji, w->offthespotWin.fs_roman,
      &w->offthespotWin.kanji_width, &w->offthespotWin.roman_width,
      &w->offthespotWin.font_height, &w->offthespotWin.font_ascent ) ;
  /* ߥ˥ХåեΥեȤξȴФƤ*/
  getFontInfo
    ( w->offthespotWin.fs_minibuf_kanji, w->offthespotWin.fs_minibuf_roman,
      &w->offthespotWin.mkanji_width, &w->offthespotWin.mroman_width,
      &w->offthespotWin.mfont_height, &w->offthespotWin.mfont_ascent ) ;
  
  OFFW_CreateAllGCs( gnew ) ;
  OFFW_CreateMinibufferGCs( gnew ) ;

  /* ¾ν*/
  w->offthespotWin.cutbuffer[ 0 ]  = '\0' ;
  w->offthespotWin.keybuf_use    = 0 ;
  w->offthespotWin.keybuf[ 0 ]   = '\0' ;

  /* ԽѤΥХåեγݡ*/
  node = skkinput_AllocateMinibuffer() ;
  node->cur_exist = True ;
  w->offthespotWin.topbuffer  = node ;
  w->offthespotWin.lastbuffer = node ;

  w->offthespotWin.jisyo_dirty = 0 ;

  /* ޤFocus ϺǽϳƤȻפ衣*/
  w->offthespotWin.is_focus = False ;

  /* Off-the-spot Window ȤƵǽ뤿ɬפѿν*/
  w->offthespotWin.focus_window  = None ;
  w->offthespotWin.input_focus_window = None ;
  w->offthespotWin.spot_x = w->offthespotWin.spot_y = 0 ;
  w->offthespotWin.focus_offset_x =
    w->offthespotWin.focus_offset_y = 0 ;
  /* Ѵ饤Ȥɽΰν򤷤Ƥ*/
  w->offthespotWin.client_area.x = 
    w->offthespotWin.client_area.y = 0 ;
  w->offthespotWin.client_area.height = 
    w->offthespotWin.client_area.width = 0 ;
  /* ơΰνԤ*/
  w->offthespotWin.status_area.x =
    w->offthespotWin.status_area.y = 0 ;
  w->offthespotWin.status_area.height = 
    w->offthespotWin.status_area.width = 0 ;

  /* ХåեȤɽ뤿˻ȤɥõƤ*/
  w->offthespotWin.canvas_probe = False ;
  w->offthespotWin.minibuffer_probe = False ;
  w->offthespotWin.modeshell_probe = False ;

  w->offthespotWin.attribute_mask = 0L ;
  return ;
}

static void OFFW_ReleaseAllGCs( Widget gw )
{
  OffthespotWinWidget w = ( OffthespotWinWidget )gw ;

  XtReleaseGC( gw, w->offthespotWin.roman_ngc ) ;
  XtReleaseGC( gw, w->offthespotWin.roman_rgc ) ;
  XtReleaseGC( gw, w->offthespotWin.kanji_ngc ) ;
  XtReleaseGC( gw, w->offthespotWin.kanji_rgc ) ;
  return ;
}

static void OFFW_ReleaseMinibufferGCs( Widget gw )
{
  OffthespotWinWidget w = ( OffthespotWinWidget )gw ;

  XtReleaseGC( gw, w->offthespotWin.mroman_ngc ) ;
  XtReleaseGC( gw, w->offthespotWin.mroman_rgc ) ;
  XtReleaseGC( gw, w->offthespotWin.mkanji_ngc ) ;
  XtReleaseGC( gw, w->offthespotWin.mkanji_rgc ) ;
  return ;
}

static void OFFW_CreateAllGCs( Widget gw )
{
  OffthespotWinWidget w = ( OffthespotWinWidget )gw ;

  w->offthespotWin.roman_ngc = 
    my_CreateGC
      ( gw, w->offthespotWin.oforeground, w->offthespotWin.obackground,
       w->offthespotWin.fs_roman ) ;
  w->offthespotWin.kanji_ngc = 
    my_CreateGC
      ( gw, w->offthespotWin.oforeground, w->offthespotWin.obackground,
       w->offthespotWin.fs_kanji ) ;
  w->offthespotWin.roman_rgc = 
    my_CreateGC
      ( gw, w->offthespotWin.obackground, w->offthespotWin.oforeground, 
       w->offthespotWin.fs_roman ) ;
  w->offthespotWin.kanji_rgc = 
    my_CreateGC
      ( gw, w->offthespotWin.obackground, w->offthespotWin.oforeground, 
       w->offthespotWin.fs_kanji ) ;
  return ;
}

static void OFFW_CreateMinibufferGCs( Widget gw )
{
  OffthespotWinWidget w = ( OffthespotWinWidget )gw ;
  Pixel foreground, background ;

  if( w->offthespotWin.change_minibuffer_font ){
    foreground = w->offthespotWin.oforeground ;
    foreground = w->offthespotWin.obackground ;
  } else {
    foreground = w->offthespotWin.foreground ;
    background = w->offthespotWin.background ;
  }
  w->offthespotWin.mroman_ngc = 
    my_CreateGC
    ( gw, foreground, background,
      w->offthespotWin.fs_minibuf_roman ) ;
  w->offthespotWin.mkanji_ngc = 
    my_CreateGC
    ( gw, foreground, background,
      w->offthespotWin.fs_minibuf_kanji ) ;
  w->offthespotWin.mroman_rgc = 
    my_CreateGC
    ( gw, background, foreground, 
      w->offthespotWin.fs_minibuf_roman ) ;
  w->offthespotWin.mkanji_rgc = 
    my_CreateGC
    ( gw, background, foreground, 
      w->offthespotWin.fs_minibuf_kanji ) ;
  return ;
}

static void OFFW_CreateCanvasOfTopBuffer
( Widget gw, Window focus_window, Window probe_window,
  Widget *popup_gw, Widget *canvas_gw,
  int *probe, XtCallbackProc callbackproc )
{
  OffthespotWinWidget w = ( OffthespotWinWidget )gw ;
  Widget line_popup, line_canvas ;

  line_popup = XtVaCreatePopupShell
    ( "topbuffer", subwindowShellWidgetClass, gw, XtNinput, TRUE, 
      XtNmappedWhenManaged, TRUE, XtNwidth, 1, XtNheight, 1, 
      XtNcolormap, w->offthespotWin.colormap,
      XtNbackground, w->offthespotWin.obackground,
      XtNparentWindow, focus_window,
      XtNprobeWindow, probe_window, NULL ) ;
  /* βˤĤɽѤ widget 롣shellwidget ľ *
   * ܽ񤤤ƤϤޤäȤΤǡġ*/
  line_canvas = XtVaCreateManagedWidget
    ( "canvas", canvasWidgetClass, line_popup, NULL ) ;
  /* Ѥ륳ХåϿ롣*/
  XtAddCallback
    ( line_canvas, XtNredrawNotify, callbackproc, gw ) ;
  XtAddCallback
    ( line_canvas, XtNdestroyNotify, 
      ( XtCallbackProc )Canvas_DestroyCallback, gw ) ;
  /* åȤβ롣*/
  XtRealizeWidget( line_popup ) ;
  XtRealizeWidget( line_canvas ) ;
  *probe = False ;
  *popup_gw  = line_popup ;
  *canvas_gw = line_canvas ;
  return ;
}

/*
 * ߥ˥ХåեβΤ˸ƤӽФؿ
 */
static void OFFW_RealizeMinibuffer( Widget gw )
{
  OffthespotWinWidget w = ( OffthespotWinWidget )gw ;
  Widget minibuffer_popup, minibuffer_canvas ;
  XSizeHints sizehints ;
  unsigned int winwidth, winheight, roman_width, roman_height ;
  Pixel foreground, background ;

  if( w->offthespotWin.change_minibuffer_font ){
    winwidth  = w->offthespotWin.roman_width *
      w->offthespotWin.minibuf_width ;
    winheight = w->offthespotWin.font_height ;
    roman_width  = w->offthespotWin.roman_width ;
    roman_height = w->offthespotWin.font_height ;
  } else {
    winwidth  = w->offthespotWin.mroman_width * 
      w->offthespotWin.minibuf_width ;
    winheight = w->offthespotWin.mfont_height ;
    roman_width  = w->offthespotWin.mroman_width ;
    roman_height = w->offthespotWin.mfont_height ;
  }
  if( w->offthespotWin.change_minibuffer_font ){
    foreground = w->offthespotWin.oforeground ;
    background = w->offthespotWin.obackground ;
  } else {
    foreground = w->offthespotWin.foreground ;
    background = w->offthespotWin.background ;
  }
  minibuffer_popup = XtVaCreatePopupShell
    ( "minibuffer", wmcloseShellWidgetClass, gw, XtNinput, TRUE, 
      XtNmappedWhenManaged, TRUE, 
      XtNwidth, winwidth, XtNheight, winheight, 
      XtNcolormap, w->offthespotWin.colormap,
      XtNreverseVideo, w->offthespotWin.reverse_video,
      XtNbackground, background,
      XtNforeground, foreground, NULL ) ;
  XtAddCallback
    ( minibuffer_popup, XtNwmcloseNotify, 
      ( XtCallbackProc )OFFW_wmMessageCloseCallback, gw ) ;
  XtAddCallback
    ( minibuffer_popup, XtNdestroyNotify, 
      ( XtCallbackProc )OFFW_wmShellDestroyCallback, gw ) ;

  /* βˤĤɽѤ widget 롣shellwidget ľ *
   * ܽ񤤤ƤϤޤäȤΤǡġ*/
  minibuffer_canvas = XtVaCreateManagedWidget
    ( "canvas", canvasWidgetClass, minibuffer_popup,
      XtNreverseVideo, w->offthespotWin.reverse_video,
      XtNbackground, background, 
      XtNforeground, foreground, NULL ) ;
  w->offthespotWin.minibuffer_probe = False ;
  /* 襤٥ȤåäƤ*/
  XtAddCallback
    ( minibuffer_canvas, XtNredrawNotify,
      ( XtCallbackProc )Minibuffer_RedisplayCallback, gw ) ;
  XtAddCallback
    ( minibuffer_canvas, XtNdestroyNotify, 
      ( XtCallbackProc )Canvas_DestroyCallback, gw ) ;

  /* ˥ߥ˥ХåեξϤƤrealize Ƥȴ*/
  w->offthespotWin.minibuffer_popup  = minibuffer_popup ;
  w->offthespotWin.minibuffer_canvas = minibuffer_canvas ;

  /* 괺ΤġXtPopDown ȤפʤΤʤ*/
  XtRealizeWidget( minibuffer_popup ) ;
  XtRealizeWidget( minibuffer_canvas ) ;

  /* Ƥ˥ꥵäƤ롩 */
  (void) XtMakeResizeRequest
    ( ( Widget )minibuffer_popup,
      ( Dimension )winwidth, ( Dimension )winheight,
      &minibuffer_popup->core.width,
      &minibuffer_popup->core.height ) ;

  /* ɥΥꥵ¾ꡣ*/
  sizehints.win_gravity = NorthWestGravity ;
  sizehints.base_width  = minibuffer_popup->core.border_width * 2 ;
  sizehints.base_height = minibuffer_popup->core.border_width * 2 ;
  sizehints.width      = winwidth + sizehints.base_width ;
  sizehints.height     = winheight + sizehints.base_height ;
  sizehints.width_inc  = roman_width ;
  sizehints.height_inc = roman_height ;
  sizehints.min_width  = roman_width * 2 + sizehints.base_width ;
  sizehints.min_height = winheight + sizehints.base_height ;
  sizehints.max_width  = roman_width * 160 + sizehints.base_width ;
  sizehints.max_height = winheight + sizehints.base_height ;
  sizehints.flags      =
    ( PBaseSize | PMinSize | PResizeInc | PMaxSize | USSize | PWinGravity ) ;

  /* Window Manager ˥ҥȤäƤ롣*/
  XSetWMNormalHints
    ( XtDisplay( gw ), XtWindow( minibuffer_popup ), &sizehints ) ;
  XFlush( XtDisplay( gw ) ) ;
  return ;
}

/*
 * Widget β˸ƤФؿ
 */
static void OFFW_Realize
( Widget gw, XtValueMask *valueMask, XSetWindowAttributes *attrs )
{
  OffthespotWinWidget w = ( OffthespotWinWidget )gw ;
  CoreWidgetClass super =
    ( CoreWidgetClass )XtClass( gw )->core_class.superclass ;

  /* ŬڤʥɥѰդƤ*/
  ( *super->core_class.realize )( gw, valueMask, attrs ) ;

  if( w->offthespotWin.client_window == None ){
    XtDestroyWidget( gw ) ;
    return ;
  }
  if( w->offthespotWin.focus_window == None ){
    w->offthespotWin.focus_window = w->offthespotWin.client_window ;
    /* եΥɥξƤʤΤʤ顢Ѱդ롣*/
    if( !( w->offthespotWin.attribute_mask & CAClientArea ) )
      XGetRectangleOfWindow
	( XtDisplay( gw ), w->offthespotWin.focus_window, 
	  &w->offthespotWin.client_area ) ;
    OFFW_ReconfigureFocusPosition( gw ) ;
  }
  /* Minibuffer 롣*/
  OFFW_RealizeMinibuffer( gw ) ;

  /* modeshell ɽΤΥåȤ롣*/
  OFFW_CreateCanvasOfTopBuffer
    ( gw, w->offthespotWin.focus_window, 
      w->offthespotWin.probe_window,
      &w->offthespotWin.modeshell_popup,
      &w->offthespotWin.modeshell_canvas,
      &w->offthespotWin.modeshell_probe,
      ( XtCallbackProc )Modeshell_RedisplayCallback ) ;
  /* modeshell Ȥ礭̵ˤƤ*/
  XtResizeWidget
    ( w->offthespotWin.modeshell_popup,
      6 * w->offthespotWin.roman_width,
      w->offthespotWin.font_height, 0 ) ;

  /* ʸѤΥХ3ɬפˤʤ롣ϥե
     ˤϤĤȤˤʤ롣*/
  OFFW_CreateCanvasOfTopBuffer
    ( gw, w->offthespotWin.focus_window, 
      w->offthespotWin.probe_window,
      &w->offthespotWin.canvas_popup,
      &w->offthespotWin.canvas,
      &w->offthespotWin.canvas_probe,
      ( XtCallbackProc )Canvas_RedisplayCallback ) ;
  /* */
  XtConfigureWidget
    ( w->offthespotWin.canvas_popup,
      w->offthespotWin.client_area.x, w->offthespotWin.client_area.y,
      w->offthespotWin.client_area.width,
      w->offthespotWin.client_area.height, 0 ) ;
     
  /* եꤹΤʤ顢focus ѲѤ뤹٤Ƥ */
  /* åȤrealizeǤʤФʤʤ*/
  XtSetKeyboardFocus( w->offthespotWin.minibuffer_popup, gw ) ;
  XtSetKeyboardFocus( w->offthespotWin.modeshell_popup, gw ) ;
  XtSetKeyboardFocus( w->offthespotWin.canvas_popup, gw ) ;
  /*
   * ΰ֤ʤ⡼ɥƤʤ
   */
  OFFW_resetupModeWindow( gw ) ;
#if 1
  OFFW_ReconfigureColor( gw, CAColor | CAColormap ) ;
#endif
  XtPopup( w->offthespotWin.canvas_popup, XtGrabNone ) ;
  w->offthespotWin.canvas_probe = True ;
  XSync( XtDisplay( gw ), False ) ;
  return ;
}

/*
 * SIW  XtDestroyWidget 򤫤˸ƤӽФؿ
 *-----
 * SIW νλ·äƤ롣GC Ƥ顢malloc Ƥ
 * Ƥ롣
 */
static void OFFW_Destroy( Widget gw )
{
  OffthespotWinWidget w = ( OffthespotWinWidget )gw ;
  struct SKKInputNode *node, *pNode ;
  /*
   * XFreeFont( XtDisplay( gw ), w->offthespotWin.fs_kanji ) ;
   * XFreeFont( XtDisplay( gw ), w->offthespotWin.fs_roman ) ;
   * ɤ顢Widget ˳ݤƤ櫓ʤߤʤΤǡ
   * ȤϤޤߤ
   */
  ignore_xerror() ;
  /* Destroy ʾ塢ʲΥɥΥ٥Ȥ̵뤹롣*/
  XSelectInput( XtDisplay( gw ), XtWindow( gw ), NoEventMask ) ;
  XSelectInput
    ( XtDisplay( gw ), XtWindow( w->offthespotWin.modeshell_popup ),
      NoEventMask ) ;
  XSelectInput
    ( XtDisplay( gw ), XtWindow( w->offthespotWin.modeshell_canvas ),
      NoEventMask ) ;
  XSelectInput
    ( XtDisplay( gw ), XtWindow( w->offthespotWin.canvas_popup ),
      NoEventMask ) ;
  XSelectInput
    ( XtDisplay( gw ), XtWindow( w->offthespotWin.canvas ),
      NoEventMask ) ;
  XSelectInput
    ( XtDisplay( gw ), XtWindow( w->offthespotWin.minibuffer_popup ),
      NoEventMask ) ;
  XSelectInput
    ( XtDisplay( gw ), XtWindow( w->offthespotWin.minibuffer_canvas ),
      NoEventMask ) ;
  /* Event Queue եå夷Ƥ*/
  XSync( XtDisplay( gw ), True ) ;
  regard_xerror() ;

  OFFW_ReleaseAllGCs( gw ) ;
  OFFW_ReleaseMinibufferGCs( gw ) ;
  /*
   * ХåեƲƤ
   */
  node = w->offthespotWin.lastbuffer ;
  while( node != NULL ){
    pNode = node->parentbuffer ;
    free_Minibuffer
      ( gw, &w->offthespotWin.topbuffer,
	&w->offthespotWin.lastbuffer, node ) ;
    node  = pNode ;
  }
  XtCallCallbacks( gw, XtNendNotify, NULL ) ;
  return ;
}

/*
 * ̤褹ؿ
 */
static void OFFW_Redisplay( Widget gw, XEvent *event, Region region )
{
  OffthespotWinWidget w = ( OffthespotWinWidget )gw ;
  /* ϲΥߥ󥰤Ǵְä Widget κ褬Ƥ롣*/
  if( w->offthespotWin.topbuffer == NULL || w->core.being_destroyed ){
#if defined(DEBUG)
    fprintf( stderr, "Illegal Widget Exposure Event.\n" ) ;
#endif
    return ;
  }
  OFFW_RedrawScreen( gw ) ;
/*  XFlush( XtDisplay( gw ) ) ;*/
  return ;
}

/*
 * 䤳ȥ饤ȤΥå򸫤ơåȤ
 * ꤹؿ
 *----
 * 饤ȥɥΰưΤ饤ȥɥ
 *  lower ꡢ raise ȡɤ褦̵褦ʵ
 * ġɤˤ臘ʤͤʤȤʤΤɤġ
 */
static int OFFW_ReconfigureWindows( Widget gw )
{
  OffthespotWinWidget w = ( OffthespotWinWidget )gw ;

  if( w->offthespotWin.minibuffer_probe ){
    XRaiseWindow
      ( XtDisplay( gw ),
	XtWindow( w->offthespotWin.minibuffer_popup ) ) ;
  }
  /* Spot Location ѲˤʸɽƤ륭Хư */
  /* ʤФʤʤν˺ä C-h ѴưԽ */
  /* ʸõ˥ɥĤ뤳Ȥˤʤ롣*/
  XtConfigureWidget
    ( w->offthespotWin.canvas_popup, w->offthespotWin.client_area.x,
      w->offthespotWin.client_area.y,
      w->offthespotWin.client_area.width,
      w->offthespotWin.client_area.height, 0 ) ;

  OFFW_RedrawScreen( gw ) ;
  w->offthespotWin.camsg = NULL ;
  return True ;
}

static void OFFW_ResizeMinibufferAndModeshell( Widget gw )
{
  OffthespotWinWidget w = ( OffthespotWinWidget )gw ;
  XSizeHints sizehints ;

  /* modeshell ξϼ¤ϸʤǤ͡줬*/
  XtResizeWidget
    ( w->offthespotWin.modeshell_popup,
      6 * w->offthespotWin.roman_width,
      w->offthespotWin.font_height, 0 ) ;

  if( w->offthespotWin.change_minibuffer_font ){
    /* 礭롣*/
    XtResizeWidget
      ( w->offthespotWin.minibuffer_popup,
	w->offthespotWin.minibuf_width *
	w->offthespotWin.roman_width,
	w->offthespotWin.font_height,
	w->offthespotWin.minibuffer_popup->core.border_width ) ;
    /* ߥ˥ХåեΥɥޥ͡㡼°롣*/
    sizehints.base_width  = 
      w->offthespotWin.minibuffer_popup->core.border_width * 2 ;
    sizehints.base_height = 
      w->offthespotWin.minibuffer_popup->core.border_width * 2 ;
    sizehints.width_inc  = w->offthespotWin.roman_width ;
    sizehints.height_inc = w->offthespotWin.font_height ;
    sizehints.min_width  = w->offthespotWin.roman_width * 2 +
      sizehints.base_width ;
    sizehints.min_height = w->offthespotWin.font_height +
      sizehints.base_height ;
    sizehints.max_width  = w->offthespotWin.roman_width * 160 + 
      sizehints.base_width ;
    sizehints.max_height = w->offthespotWin.font_height +
      sizehints.base_height ;
    sizehints.flags = ( PBaseSize | PMinSize | PResizeInc | PMaxSize ) ;
    XChangeWMNormalHints
      ( XtDisplay( gw ),
	XtWindow( w->offthespotWin.minibuffer_popup ),
	&sizehints ) ;
  } else {
    /* 礭롣*/
    XtResizeWidget
      ( w->offthespotWin.minibuffer_popup,
	w->offthespotWin.minibuf_width *
	w->offthespotWin.mroman_width,
	w->offthespotWin.mfont_height,
	w->offthespotWin.minibuffer_popup->core.border_width ) ;
  }
  return ;
}

/*
 * Ѵ饤Ȥʿڤطʿ顼ޥåפѹ줿ˡ
 * GC κԤؿ
 */
static void OFFW_ReconfigureColor( Widget gw, unsigned long valuemask )
{
  OffthespotWinWidget w = ( OffthespotWinWidget )gw ;
  Arg args[ 3 ] ;
  Cardinal num_args = 0 ;

  /* طʿѹ줿ΤǤ */
  if( valuemask & CAColor ){
    XtSetArg
      ( args[ num_args ], XtNbackground, w->offthespotWin.obackground ) ;
    num_args ++ ;
  }
  /* 顼ޥåפѹ줿ΤǤ */
  if( valuemask & CAColormap ){
    XtSetArg
      ( args[ num_args ], XtNcolormap, w->offthespotWin.colormap ) ;
    num_args ++ ;
  }
  if( num_args > 0 ){
    /*   ֤󡣤ʤꤷʤȤʤΤġ      *
     * աϳƥɥطʿȥ顼ޥåפκ* 
     * Ƥ롣                                                    *
     * ե꡼֥եȤ衢եȡ                          */
    XtSetValues( w->offthespotWin.modeshell_popup, args, num_args ) ;
    XtSetValues( w->offthespotWin.modeshell_canvas, args, num_args ) ;
    if( w->offthespotWin.change_minibuffer_font ){
      XtSetValues( w->offthespotWin.minibuffer_popup, args, num_args ) ;
      XtSetValues( w->offthespotWin.minibuffer_canvas, args, num_args ) ;
    }
    XtSetValues( w->offthespotWin.canvas_popup, args, num_args ) ;
    XtSetValues( w->offthespotWin.canvas, args, num_args ) ;
  }
  /* ѹʤä顢GC Ϻľʤɤ 顼ޥ
     פϤɤΤ */
  if( !( valuemask & CAColor ) )
    return ;

  /* ޤȤäƤ GC Ʋ롣 minibuffer οä *
   * ѹ٤ʡ  */
  OFFW_ReleaseAllGCs( gw ) ;
  OFFW_CreateAllGCs( gw ) ;
  return ;
}

/*
 * åȴ֤ΥåȤؿ
 */
static Boolean OFFW_SetValues
( Widget current, Widget request, Widget new,
  ArgList args, Cardinal *num_args )
{
  OffthespotWinWidget curw = ( OffthespotWinWidget )current ;
  OffthespotWinWidget reqw = ( OffthespotWinWidget )request ;
  OffthespotWinWidget neww = ( OffthespotWinWidget )new ;
  struct ConvAttrsMesg *camsg ;

  /* 񤬽Ƥ顢ľ¹Ԥ롣*/
  if( curw->offthespotWin.jisyo_dirty != reqw->offthespotWin.jisyo_dirty ){
    neww->offthespotWin.jisyo_dirty = reqw->offthespotWin.jisyo_dirty ;
    /* 뤬Ƥʤм¹Ԥʤȡ*/
    if( neww->offthespotWin.modeshell_probe ){
      XtVaSetValues
	( neww->offthespotWin.modeshell_canvas,
	  XtNredrawRequest, True, NULL ) ;
    }
    return False ;
  }
  /* Ѵ°ν׵᤬褿ȸդꡣ*/
  if( reqw->offthespotWin.camsg != NULL ){
    int ret ;
    /* Ѵ°ˤǸ­Τɤ *
     * äƤߤäʤ͡                                     *
     * ա֤Ǥ͡äƤߤޤ礦Ĥ󡪡             */
    camsg = reqw->offthespotWin.camsg ;
    reqw->offthespotWin.camsg = neww->offthespotWin.camsg = 
      curw->offthespotWin.camsg = NULL ;

    ret = OFFW_ChangeAttributes
      ( new, camsg->mask, &camsg->value ) ;

    if( XtIsRealized( new ) )
      OFFW_ReconfigureWindows( new ) ;
    return ret ;
  }
  /* ߥ˥ХåեõȤ˾νԤ*/
  if( reqw->offthespotWin.clearMinibuffer ){
    if( curw->offthespotWin.minibuffer_probe ){
      XtPopdown( curw->offthespotWin.minibuffer_popup ) ;
      curw->offthespotWin.minibuffer_probe =
	neww->offthespotWin.minibuffer_probe = False ;
    }
    reqw->offthespotWin.clearMinibuffer =
      neww->offthespotWin.clearMinibuffer = 
      curw->offthespotWin.clearMinibuffer = False ;
    return FALSE ;
  }
  /* ݥåץåפ롣*/
  if( reqw->offthespotWin.conversion_set_focus ){
    reqw->offthespotWin.conversion_set_focus = 
      neww->offthespotWin.conversion_set_focus = 
      curw->offthespotWin.conversion_set_focus = False ;
    if( !neww->offthespotWin.modeshell_probe ){
      XtPopup( neww->offthespotWin.modeshell_popup, XtGrabNone ) ;
      neww->offthespotWin.modeshell_probe = True ;
    }
    if( !neww->offthespotWin.canvas_probe ){
      XtPopup( neww->offthespotWin.canvas_popup, XtGrabNone ) ;
      neww->offthespotWin.canvas_probe = True ;
    }
    /* ߥ˥ХåեƤ⤷ʤΤ褵롣*/
    OFFW_ConfigureMinibuffer( new ) ;
    return FALSE ;
  }
  /* ݥåץ󤹤롣*/
  if( reqw->offthespotWin.conversion_unset_focus ){
    reqw->offthespotWin.conversion_unset_focus = 
      neww->offthespotWin.conversion_unset_focus = 
      curw->offthespotWin.conversion_unset_focus = False ;
    if( neww->offthespotWin.modeshell_probe ){
      XtPopdown( neww->offthespotWin.modeshell_popup ) ;
      neww->offthespotWin.modeshell_probe = False ;
    }
    if( neww->offthespotWin.canvas_probe ){
      XtPopdown( neww->offthespotWin.canvas_popup ) ;
      neww->offthespotWin.canvas_probe = False ;
    }
    return FALSE ;
  }
  return( FALSE ) ;
}

static int OFFW_ReconfigureFocusPosition
( Widget gw )
{
  OffthespotWinWidget w = ( OffthespotWinWidget )gw ;
  int x, y, ofx, ofy ;
  Window dummy ;
  int ret = False ;
  /* 롼ȥɥǤΥեɥа֤򻻽 *
   * 롣*/
  XTranslateCoordinates
    ( XtDisplay( gw ), w->offthespotWin.client_window,
      RootWindowOfScreen( XtScreen( gw ) ),
      0, 0, &x, &y, &dummy ) ;
  if( w->offthespotWin.focus_window != w->offthespotWin.client_window ){
    XTranslateCoordinates
      ( XtDisplay( gw ), w->offthespotWin.focus_window,
	w->offthespotWin.client_window, 
	0, 0, &ofx, &ofy, &dummy ) ;
  } else {
    ofx = ofy = 0 ;
  }
  if( w->offthespotWin.client_x != x || w->offthespotWin.client_y != y ){
    w->offthespotWin.client_x = x ;
    w->offthespotWin.client_y = y ;
    ret = True ;
  }
  if( w->offthespotWin.focus_offset_x != ofx ||
      w->offthespotWin.focus_offset_y != ofy ){
    w->offthespotWin.focus_offset_x = ofx ;
    w->offthespotWin.focus_offset_y = ofy ;
    ret = True ;
  }
  return ret ;
}

/*
 * Ѵ饤ȤΡѴ°ν׵פ򤵤Фؿ
 */
static int OFFW_ChangeAttributes
( Widget gw, unsigned long valuemask, struct ConvAttrs *values )
{
  OffthespotWinWidget w   = ( OffthespotWinWidget )gw ;
  int ret = False, rec_col ;

  if( valuemask & CAStatusArea ){
    /* ɸνä⤷ɽΰ褬Ƥ硣*/
    if( values->status_area.x != w->offthespotWin.status_area.x ||
        values->status_area.y != w->offthespotWin.status_area.y ||
        values->status_area.width  != w->offthespotWin.status_area.width || 
        values->status_area.height != w->offthespotWin.status_area.height ){
      w->offthespotWin.status_area.x = values->status_area.x ;
      w->offthespotWin.status_area.y = values->status_area.y ;
      w->offthespotWin.status_area.width  = values->status_area.width ;
      w->offthespotWin.status_area.height = values->status_area.height ;
      w->offthespotWin.attribute_mask |= CAStatusArea ;
      ret = True ;
    }
  }
  rec_col = False ;
  /* 顼ޥåפѹ׵᤬褿硣*/
  if( ( valuemask & CAColormap ) &&
     w->offthespotWin.colormap != values->colormap ){
    w->offthespotWin.colormap = values->colormap ;
    rec_col = True ;
  }
  /* طʿʿѹ׵᤬褿硣*/
  if( ( valuemask & CAColor ) &&
     ( w->offthespotWin.obackground != values->background ||
       w->offthespotWin.oforeground != values->foreground ) ){
    w->offthespotWin.obackground = values->background ;
    w->offthespotWin.oforeground = values->foreground ;
    rec_col = True ;
  }
  if( XtIsRealized( gw ) && rec_col ){
    OFFW_ReconfigureColor( gw, valuemask ) ;
  }
  /* Ѵ饤ȤɽΰνΤ褿ν*/
  if( valuemask & CAClientArea ){
    /* ɸνä⤷ɽΰ褬Ƥ硣*/
    if( values->client_area.x != w->offthespotWin.client_area.x ||
        values->client_area.y != w->offthespotWin.client_area.y ||
        values->client_area.width != w->offthespotWin.client_area.width || 
        values->client_area.height != w->offthespotWin.client_area.height ){
      /* Ѵ饤ȤɽΰѹФƤ*/
      w->offthespotWin.client_area    = values->client_area ;
#ifdef DEBUG
      fprintf( stderr, "Get client area pos:(%d,%d), size:%d x %d.\n",
	       w->offthespotWin.client_area.x,
	       w->offthespotWin.client_area.y,
	       w->offthespotWin.client_area.width,
	       w->offthespotWin.client_area.height ) ;
#endif
      w->offthespotWin.attribute_mask |= CAClientArea ;
      ret = True ;
    }
  } else if( valuemask & CAFocusWindow ){
#ifdef DEBUG
    fprintf
      ( stderr, "Get focus window (%ld)\n", values->focus_window ) ;
#endif
    /* եäƼºߤΡ Ȥ¤Ϥ⤦ä *
     * ɬפȻפ*/
    if( values->focus_window != None ){
      /* ꤷȦΥեʪˤʤäƤ顢̣Ǥ */
      /* ʤ ȤäǤ*/
      if( w->offthespotWin.focus_window != None ){
	XtDestroyWidget( gw ) ;
	return False ;
      }
      w->offthespotWin.focus_window = values->focus_window ;

      /* Ѵ饤ȤΰФ̵ä鼫Ѱդ *
       * 줬ɤʤݾڤϤʤΤɡѴ *
       * Ȥʤ̵ */
      if( !(( w->offthespotWin.attribute_mask ) & CAClientArea )){
	XGetRectangleOfWindow
	  ( XtDisplay( gw ), w->offthespotWin.focus_window, 
	    &w->offthespotWin.client_area ) ;
      }
      /* ơΰ褬ꤵƤʤä顢Ȥꤢϥ饤
	 ΰѤ롣ΤޤޤǤФ˸ɤΤ
	 ץꥱ¦Ȥ뤳ȡ*/
      if( !(( w->offthespotWin.attribute_mask ) & CAStatusArea ) ){
	w->offthespotWin.status_area = w->offthespotWin.client_area ; 
      }
      ret = True ;
    }
  }
  /* ɸȤ׵᤬ƤνԤ*/
  if( valuemask & CASpotLocation ){
    if( w->offthespotWin.focus_window != None ){
      int prev_focus ;
#if defined(DEBUG)
      fprintf( stderr, "CASPOT nanode FOCUSWINDOW miru (%ld).\n",
	      w->offthespotWin.focus_window ) ;
#endif
      prev_focus = w->offthespotWin.is_focus ;
      w->offthespotWin.is_focus = focusCheck( gw ) ;
      if( prev_focus != w->offthespotWin.is_focus ){
	ret = True ;
      }
      if( OFFW_ReconfigureFocusPosition( gw ) )
	ret = True ;
    }
    if( values->spot_x != w->offthespotWin.spot_x ||
	values->spot_y != w->offthespotWin.spot_y ){
#ifdef DEBUG
      fprintf( stderr, "Get Basho Shitei meirei.\n" ) ;
#endif
      /* ֤뤵*/
      w->offthespotWin.spot_x = values->spot_x ;
      w->offthespotWin.spot_y = values->spot_y ;
      ret = True ;
    }
  }
#if 0
  else if( valuemask & CAFocusWindow &&
	    w->offthespotWin.focus_window != None ){
    /* եƤɥưƤ⤳ƤФΤ * 
     * եɤľȤˤ롣kinput2 Ȥɤ *
     * Τʬʤɡ꤬ФƤͤ뤵*/
    XTranslateCoordinates
      ( XtDisplay( gw ), w->offthespotWin.focus_window,
	RootWindowOfScreen( XtScreen( gw ) ),
	0, 0, &x, &y, &child ) ;
    w->offthespotWin.focus_offset_x = x ;
    w->offthespotWin.focus_offset_x = y ;
    ret = True ;
    /*  Ŭ˸߻ȤäƤեȡΤޤޤǤäƤ롣*/
  }
#endif
  /* եȾνäν*/
  if( valuemask & CAFonts ){
#ifdef DEBUG
    fprintf( stderr, "FONT WO KIRIKAERU.\n" ) ;
#endif
    /* եȤڤؤ롣*/
    if( values->fontset[ 0 ] != NULL ){
      w->offthespotWin.fs_roman = values->fontset[ 0 ] ;
    } else {
      /* ꤨʤեȤλ꤬褿ˤϡǥեȤ᤹*/
      w->offthespotWin.fs_roman = w->offthespotWin.fs_default_roman ;
    }
    if( values->fontset[ 1 ] != NULL ){
      w->offthespotWin.fs_kanji = values->fontset[ 1 ] ;
    } else {
      /* ꤨʤեȤλ꤬褿ˤϡǥեȤ᤹*/
      w->offthespotWin.fs_kanji = w->offthespotWin.fs_default_kanji ;
    }
    /* եȾ롣*/
    getFontInfo
      ( w->offthespotWin.fs_kanji, w->offthespotWin.fs_roman,
	&w->offthespotWin.kanji_width, &w->offthespotWin.roman_width,
	&w->offthespotWin.font_height, &w->offthespotWin.font_ascent ) ;
    /* ޤåȤβƤˤϴ GC ȤѰդ */
    /* ƤޤäƤΤǡʤФʤʤ*/ 
    if( XtIsRealized( gw ) ){
      /* ߥ˥Хåեȥ⡼ɥ礭롣*/
      OFFW_ResizeMinibufferAndModeshell( gw ) ;
      /* ޤȤäƤ GC Ʋ롣*/
      OFFW_ReleaseAllGCs( gw ) ;
      /* ľ*/
      OFFW_CreateAllGCs( gw ) ;
    }
    ret = True ;
  }
#undef XQueryRaiseWindow

  return ret ;
}

enum {
  SIW_DESTROYED = -1, SIW_PROCESSING = 0,
} ;

/*
 * 줿Ȥ٥ȤνԤؿ
 *----
 * Υ줿ȤԲǽʾ礬Τǡ줿Ȥ
 * Ǿ꤯ư褦˺ʤФʤʤ
 */
static void KeyDownEventHandler
( Widget gw, XEvent *xevent, String *params, Cardinal *num_params )
{
  OffthespotWinWidget w = ( OffthespotWinWidget )gw ;
  char inpstr[ STRBUFSIZE ] ;
  KeySym key ;
  struct SKKInputNode *node, *topbuffer ;

  /* 줿ΤǤʤȴ롣*/
  if( xevent->type != KeyPress )
    return ;

  /* ٥Ȥ򵭲Ƥ*/
  w->offthespotWin.xevent = *xevent ;

  /* ߥ˥Хåե¸ߤƤΤʤСΰֺǸΤΤ򤹤롣*/
  topbuffer = w->offthespotWin.topbuffer ;
  node      = w->offthespotWin.lastbuffer ;
  if( !node->cur_exist )
    node = topbuffer ;

  /* ʸХåեν*/
  inpstr[ 0 ] = '\0' ;
  /* ʸ*/
  XLookupString( &( xevent->xkey ), inpstr, STRBUFSIZE, &key, NULL ) ;
  
  /* եȥڡξνԤ*/
  if( ( xevent->xkey.state & ShiftMask ) && key == XK_space ){
    XtDestroyWidget( gw ) ;
    return ;
  }
  
  /* Ϥ줿ʸϰ̣ʸʤΤǤ */
  if( inpstr[ 0 ] != '\0' ){
    w->offthespotWin.keybuf[ w->offthespotWin.keybuf_use ++ ] =
      inpstr[ 0 ] ;
    /* ߥ˥Хåե¸ߤѤƤν*/
    switch( do_function_by_reading_character( gw, node ) ){
    case SIW_DESTROYED :
      XtDestroyWidget( gw ) ;
      return ;
    case SIW_PROCESSING :
      break ;
    default :
      return ;
    }
  } else {
    /* ȥ륹ڡξνԤ string  */
    /* ʤȦʤΤǡ*/
    if( ( xevent->xkey.state & ControlMask ) && key == XK_space ){
      w->offthespotWin.keybuf[ w->offthespotWin.keybuf_use ++ ] = 0x00 ;
      if( do_function_by_reading_character( gw, node ) )
	return ;
      OFFW_RedrawScreen( gw ) ;
      return ;
    }
    /* skkinput ǤǧǤʤ̣뤫⤷ʤ֤*/
    if( topbuffer->textbuffer[ 0 ] == '\0' &&
        topbuffer->minibuffer == NULL ){
      j_sendback_keypress( gw, &( w->offthespotWin.xevent ) ) ;
    }
  }
  /*skkinput_DrawScreen( gw ) ;*/
  /* ̤ľĺʬǤΤʤ*/
  OFFW_RedrawScreen( gw ) ;
/*  XFlush( XtDisplay( gw ) ) ;*/
  return ;
}

/*
 * ߥޥեƤ뤫ɤå뤿δؿ
 *-----
 * ΤƤХȤơեΰư˾꤯ȡ
 * Pointer ¸ߤƤ뤳ȤƨƤޤȤġʤʬ
 * 뤫
 */
static int focusCheck( Widget gw )
{
  OffthespotWinWidget w = ( OffthespotWinWidget )gw ;
  Window mouse_focus, rootwin, childwin ;
  int ret_focus_state ;
  int rootx, rooty, winx, winy ;
  unsigned int winmask ;
  
  /* ޤޥΥեåäƤͤդ롣*/
  XGetInputFocus
    ( XtDisplay( gw ), &mouse_focus, &ret_focus_state ) ;

#if defined(DEBUG)
  fprintf( stderr, "Mouse Focus Window:(%ld)\n", mouse_focus ) ;
#endif
  if( mouse_focus == None || mouse_focus == PointerRoot )
    return False ;

  if( w->offthespotWin.input_focus_window != None ){
    if( mouse_focus == w->offthespotWin.input_focus_window )
      return True ;
  } 
  if( XQueryPointer
     ( XtDisplay( gw ), mouse_focus,
       &rootwin, &childwin, &rootx, &rooty, &winx, &winy, 
       &winmask ) ){
#if defined(DEBUG)
    fprintf
      ( stderr, "Focus Root Window:(%ld), Focus Child Window:(%ld)\n",
        rootwin, childwin ) ;
#endif
    /* Ѵ饤ȤޥΥեäƤ롢⤷ */
    /* ϤλҶޥΥեäƤΤʤ True */
    if( w->offthespotWin.focus_window == childwin ){
      if( w->offthespotWin.input_focus_window == None ){
	w->offthespotWin.input_focus_window = mouse_focus ;
      }
      return True ;
    }
    if( w->offthespotWin.focus_window == mouse_focus )
      return True ;
    /* ߥ˥ХåեɥƤ⤢衣*/
    if( w->offthespotWin.minibuffer_probe ){
      if( XtWindow( w->offthespotWin.minibuffer_popup ) == childwin )
	return True ;
      if( XtWindow( w->offthespotWin.minibuffer_popup ) == mouse_focus )
	return True ;
    }
  }
  return False ;
}

/*
 * ե蘆줿νԤؿ
 */
static void FocusEventHandler
( Widget gw, XEvent *xevent, String *params, Cardinal *num_params )
{
  OffthespotWinWidget w = ( OffthespotWinWidget )gw ;
  int prev_focus ;

  /* եɥޤäƤʤΤˡʥեIN ʤ */
  /* äƤ礸ʤ*/
  if( w->offthespotWin.focus_window == None )
    return ;
  /* ޤϥե򼺤äΤȹͤ롣*/
  prev_focus = w->offthespotWin.is_focus ;
  w->offthespotWin.is_focus = focusCheck( gw ) ;
  /* ̤νĥηѲΤǡ*/
  if( prev_focus != w->offthespotWin.is_focus )
    OFFW_RedrawScreen( gw ) ;
  return ;
}

/*
 * ʲΥեϡOffthespotWinWidget ΥΰǤ롣
 */

/*
 * ơ֥򻲾Ȥ̤Υե󥯥ֹ˽äƽ¹Ԥ
 * ٤¾δؿƽФԤؿ
 */
static int do_skkinputFunction_withtext
( Widget gw, struct SKKInputNode *node,	int func_no )
{
  OffthespotWinWidget w = ( OffthespotWinWidget )gw ;
  int chara = w->offthespotWin.keybuf[ 0 ] ;

  /* ȡΥåХåե˽񤫤Ƥ *
   * Ͼä뤳ȤˤʤäƤ롩 */
  node->mtextbuffer[ 0 ] = '\0' ;

  /* 䴰ײλ뤫ɤ*/
  if( node->j_completion_mode ){
    if( func_no != FUNCNO_J_INSERT_PERIOD &&
	func_no != FUNCNO_J_INSERT_COMMA  &&
	func_no != FUNCNO_J_ABBREV_PERIOD &&
	func_no != FUNCNO_J_ABBREV_COMMA  ){
      j_completion_close( node ) ;
    }
  }
  /* Ϳ줿̿ФԤ*/
  switch( func_no ){
  case FUNCNO_J_PREFIX_CHAR :
    j_delete_kanaprefix( node ) ;
    /* ֢ΥХåեʤСC- Ȥɽ롣*/
    if( node == ( w->offthespotWin ).topbuffer ){
      strcpy( node->mtextbuffer,
	     charaToString( w->offthespotWin.keybuf[ 0 ] ) ) ;
      strcat( node->mtextbuffer, "-" ) ;
    }
    return SIW_PROCESSING ;
  case FUNCNO_SELF_INSERT_CHARACTER :
    j_insert_chara( node, node->cur_pos, chara ) ;
    break ;
  case FUNCNO_J_SELF_INSERT :
    j_self_insert
      ( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer,
	node, chara ) ;
    break ;
  case FUNCNO_J_SELF_ZENKAKU_INSERT :
    j_insert_zenkaku( node, node->cur_pos, chara ) ;
    break ;
  case FUNCNO_J_DISPLAY_CODE_FOR_CHAR_AT_POINT :
    j_display_code_for_char_at_point( node ) ;
    break ;
  case FUNCNO_J_SET_HENKAN_POINT :
    /* Ѵϰ֤ꤵ롣*/
    j_set_henkan_point
      ( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer,
	node, chara ) ;
    break ;
  case FUNCNO_J_SET_HENKAN_POINT_SUBR :
    j_set_henkan_point_subr
      ( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer, 
	node, chara ) ;
    break ;
    /* 첻ϡ*/
  case FUNCNO_J_INSERT_A :
    j_insert_a
      ( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer,
	node, chara ) ;
    break ;
  case FUNCNO_J_INSERT_E :
    j_insert_e
      ( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer,
	node, chara ) ;
    break ;
  case FUNCNO_J_INSERT_I :
    j_insert_i
      ( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer,
	node, chara ) ;
    break ;
  case FUNCNO_J_INSERT_O :
    j_insert_o
      ( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer,
	node, chara ) ;
    break ;
  case FUNCNO_J_INSERT_U :
    j_insert_u
      ( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer,
	node, chara ) ;
    break ;
    /* ̾Ϥγϥ( ҲǤ )*/
  case FUNCNO_J_KANA_INPUT :
    j_kana_input
      ( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer, 
	node, chara ) ;
    break ;
  case FUNCNO_J_START_HENKAN :
    j_start_henkan
      ( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer,
	node ) ;
    break ;
  case FUNCNO_J_INSERT_COMMA :
    j_insert_comma
      ( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer,
	node ) ;
    break ;
  case FUNCNO_J_INSERT_PERIOD :
    j_insert_period
      ( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer,
	node ) ;
    break ;
  case FUNCNO_J_PURGE_FROM_JISYO :
    j_purge_from_jisyo( gw, &w->offthespotWin.lastbuffer, node ) ;
    break ;
  case FUNCNO_J_INPUT_BY_CODE_OR_MENU :
    j_input_by_code_or_menu_start
      ( gw, &w->offthespotWin.lastbuffer, node ) ;
    break ;
  case FUNCNO_J_MODE_OFF :
    j_mode_off
      ( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer,
	node, chara ) ;
    break ;
  case FUNCNO_J_MODE_OFF_AND_SELF_INSERT :
    j_mode_off_and_self_insert
      ( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer,
	node, chara ) ;
    break ;
  case FUNCNO_J_TOGGLE_KANA :
    /* ̾⡼ɤҲ̾⡼ɤڤؤ*/
    j_toggle_kana
      ( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer, 
	node, False, chara ) ;
    break ;
  case FUNCNO_J_PREVIOUS_CANDIDATE :
    j_previous_candidate
      ( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer,
	node ) ;
    break ;
  case FUNCNO_J_KAKUTEI :
    if( j_kakutei_kana_mode
	( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer, 
	  node, chara ) )
      break ;
    j_kakutei( gw, node) ;
    break ;
  case FUNCNO_J_ABBREV_INPUT :
    j_abbrev_input
      ( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer, 
	node, chara ) ;
    break ;
  case FUNCNO_J_ABBREV_PERIOD :
    j_abbrev_period( gw, node ) ;
    break ;
  case FUNCNO_J_ABBREV_COMMA :
    j_abbrev_comma( gw, node ) ;
    break ;
  case FUNCNO_J_ZENKAKU_EIJI :
    /* (Ѥܸ)ѻϥ⡼ɤˤ롣*/
    j_zenkaku_eiji
      ( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer, 
	node, chara ) ;
    break ;
  case FUNCNO_J_ZENKAKU_HENKAN :
    j_zenkaku_henkan( gw, node ) ;
    break ;
  case FUNCNO_J_TODAY :
    /* դνϡ*/
    j_today( node ) ;
    break ;
  case FUNCNO_J_KANAINPUT_MODE_ON :
    j_kanainput_mode_on
      ( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer,
	node ) ;
    break ;
  case FUNCNO_J_SET_MARK_COMMAND :
    j_set_mark_command( node ) ;
    break ;
  case FUNCNO_J_NEWLINE :
    j_newline
      ( gw, &( w->offthespotWin.xevent ), False,
	&w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer,
	node, w->offthespotWin.egg_like_newline,
	w->offthespotWin.chat_adapter,
	NULL, NULL, NULL, NULL ) ;
    break ;
  case FUNCNO_J_FORWARD_CHAR :
    j_forward_char( node ) ;
    break ;
  case FUNCNO_J_BACKWARD_CHAR :
    j_backward_char( node ) ;
    break ;
  case FUNCNO_J_DELETE_CHAR :
    j_delete_char( node ) ;
    break ;
  case FUNCNO_J_DELETE_BACKWARD_CHAR :
    j_backward_delete_char
      ( gw, &w->offthespotWin.topbuffer,
        &w->offthespotWin.lastbuffer, node,
        &w->offthespotWin.xevent, True ) ;
    break ;
  case FUNCNO_J_TRY_COMPLETION :
    j_try_completion( gw, node ) ;
    break ;
  case FUNCNO_J_END_OF_LINE :
    j_end_of_line( node ) ;
    break ;
  case FUNCNO_J_BEGINNING_OF_LINE :
    j_beginning_of_line( node ) ;
    break ;
  case FUNCNO_J_KILL_LINE :
    j_kill_line( node, w->offthespotWin.cutbuffer ) ;
    break ;
  case FUNCNO_J_KILL_REGION :
    j_kill_region( node, w->offthespotWin.cutbuffer ) ;
    break ;
  case FUNCNO_J_KILL_RING_SAVE :
    j_kill_ring_save( node, w->offthespotWin.cutbuffer ) ;
    break ;
  case FUNCNO_J_EXCHANGE_POINT_AND_MARK :
    j_exchange_point_and_mark( node ) ;
    break ;
  case FUNCNO_J_YANK :
    j_yank( node, w->offthespotWin.cutbuffer ) ;
    break ;
  case FUNCNO_J_PREVIOUS_LINE :
    break ;
  case FUNCNO_J_NEXT_LINE :
    break ;
  case FUNCNO_J_TRANSPOSE_CHARS :
    j_transpose_chars( node ) ;
    break ;
  case FUNCNO_J_REDRAW :
    /* öե褹롣ʬǤϤʤơ*/
    OFFW_RedrawScreen( gw ) ;
    break ;
  case FUNCNO_J_KEYBOARD_QUIT :
    j_keyboard_quit
      ( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer, node ) ;
    break ;
  case FUNCNO_SAVE_SKKINPUT_LOCAL_JISYO :
    j_delete_kanaprefix( node ) ;
    /* 񤬹Ƥ뤫ɤȽꤹ롣*/
    if( w->offthespotWin.jisyo_dirty ){
      strcpy( node->mtextbuffer, "Saving Jisyo..." ) ;
      /*skkinput_DrawScreen( gw ) ;*/
      OFFW_RedrawScreen( gw ) ;
/*      XFlush( XtDisplay( gw ) ) ;*/
      /* ι򤹤륳ХåƽФ*/
      skkinput_updateLocalJisyo() ;
      
      strcat( node->mtextbuffer, "done" ) ;
    } else {
      err_msg( node, "(No changes need to be saved)" ) ;
    }
    break ;
  case FUNCNO_CLOSE_SKKINPUT :
    return SIW_DESTROYED ;
  case FUNCNO_VC_TOGGLE_CHATMODE :
    j_delete_kanaprefix( node ) ;
    w->offthespotWin.chat_adapter =
      ( w->offthespotWin.chat_adapter )? False : True ;
    break ;
  case FUNCNO_VC_TOGGLE_EGGNL :
    j_delete_kanaprefix( node ) ;
    w->offthespotWin.egg_like_newline =
      ( w->offthespotWin.egg_like_newline )? False : True ;
    break ;
  case FUNCNO_NOT_MODIFIED :
    j_delete_kanaprefix( node ) ;
    /* ѹե饰õ롣*/
    j_clear_modified_flag() ;
    strcpy( node->mtextbuffer, "Modification-flag cleared" ) ;
    break ;
  case FUNCNO_J_FORWARD_WORD :
    j_forward_word( node ) ;
    break ;
  case FUNCNO_J_BACKWARD_WORD :
    j_backward_word( node ) ;
    break ;
  case FUNCNO_J_UPCASE_WORD :
    j_caseword( node, 'u' ) ;
    break ;
  case FUNCNO_J_DOWNCASE_WORD :
    j_caseword( node, 'd' ) ;
    break ;
  case FUNCNO_J_CAPITALIZE_WORD :
    j_caseword( node, 'c' ) ;
    break ;
  case FUNCNO_INVALID_CHAR :
  default :
#if 0
    XBell( XtDisplay( gw ), 5 ) ;
#endif
    break ;
  }
  w->offthespotWin.keybuf_use  = 0 ;
  w->offthespotWin.keybuf[ 0 ] = '\0' ;

  return SIW_PROCESSING ;
}

/*
 * ơ֥򻲾Ȥ̤Υե󥯥ֹ˽äƽ¹Ԥ
 * ٤¾δؿƽФԤؿ
 */
static int do_skkinputFunction_withouttext
( Widget gw, struct SKKInputNode *node,	int func_no )
{
  OffthespotWinWidget w = ( OffthespotWinWidget )gw ;
  int chara = w->offthespotWin.keybuf[ 0 ] ;

  /* ȡΥåХåե˽񤫤Ƥ *
   * Ͼä뤳ȤˤʤäƤ롩 */
  node->mtextbuffer[ 0 ] = '\0' ;

  /* 褿ɬ completion Ͻλ뤳Ȥˤʤ롣*/
  if( node->j_completion_mode ){
    j_completion_close( node ) ;
  }
  /* Ϳ줿̿ФԤʸʳ̵뤹롣*/
  switch( func_no ){
  case FUNCNO_SELF_INSERT_CHARACTER :
    j_insert_chara( node, node->cur_pos, chara ) ;
    break ;
  case FUNCNO_J_SELF_INSERT :
    j_self_insert
      ( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer,
	node, chara ) ;
    break ;
  case FUNCNO_J_SELF_ZENKAKU_INSERT :
    j_insert_zenkaku( node, node->cur_pos, chara ) ;
    break ;
  case FUNCNO_J_SET_HENKAN_POINT :
    /* Ѵϰ֤ꤵ롣*/
    j_set_henkan_point
      ( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer,
	node, chara ) ;
    break ;
  case FUNCNO_J_SET_HENKAN_POINT_SUBR :
    j_set_henkan_point_subr
      ( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer, 
	node, chara ) ;
    break ;
    /* 첻ϡ*/
  case FUNCNO_J_INSERT_A :
    j_insert_a
      ( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer,
	node, chara ) ;
    break ;
  case FUNCNO_J_INSERT_E :
    j_insert_e
      ( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer,
	node, chara ) ;
    break ;
  case FUNCNO_J_INSERT_I :
    j_insert_i
      ( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer,
	node, chara ) ;
    break ;
  case FUNCNO_J_INSERT_O :
    j_insert_o
      ( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer,
	node, chara ) ;
    break ;
  case FUNCNO_J_INSERT_U :
    j_insert_u
      ( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer,
	node, chara ) ;
    break ;
    /* ̾Ϥγϥ( ҲǤ )*/
  case FUNCNO_J_KANA_INPUT :
    j_kana_input
      ( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer, 
	node, chara ) ;
    break ;
  case FUNCNO_J_START_HENKAN :
    j_start_henkan
      ( gw, &w->offthespotWin.topbuffer,
        &w->offthespotWin.lastbuffer, node ) ;
    break ;
  case FUNCNO_J_INSERT_COMMA :
    j_insert_comma
      ( gw, &w->offthespotWin.topbuffer,
        &w->offthespotWin.lastbuffer, node ) ;
    break ;
  case FUNCNO_J_INSERT_PERIOD :
    j_insert_period
      ( gw, &w->offthespotWin.topbuffer,
        &w->offthespotWin.lastbuffer, node ) ;
    break ;
  case FUNCNO_J_INPUT_BY_CODE_OR_MENU :
    j_input_by_code_or_menu_start
      ( gw, &w->offthespotWin.lastbuffer, node ) ;
    break ;
  case FUNCNO_J_MODE_OFF :
    j_mode_off
      ( gw, &w->offthespotWin.topbuffer,
        &w->offthespotWin.lastbuffer, node, chara ) ;
    /* Ϻƹͤ;Ϥꡣ˽롣*/
    break ;
  case FUNCNO_J_MODE_OFF_AND_SELF_INSERT :
    j_mode_off_and_self_insert
      ( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer,
	node, chara ) ;
    break ;
  case FUNCNO_J_TOGGLE_KANA :
    /* ̾⡼ɤҲ̾⡼ɤڤؤ*/
    j_toggle_kana
      ( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer, 
	node, False, chara ) ;
    break ;
  case FUNCNO_J_PREVIOUS_CANDIDATE :
    j_previous_candidate
      ( gw, &w->offthespotWin.topbuffer,
        &w->offthespotWin.lastbuffer, node ) ;
    break ;
  case FUNCNO_J_KAKUTEI :
    if( j_kakutei_kana_mode
	( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer, 
	  node, chara ) )
      break ;
    j_kakutei( gw, node ) ;
    break ;
  case FUNCNO_J_ABBREV_INPUT :
    j_abbrev_input
      ( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer, 
	node, chara ) ;
    break ;
  case FUNCNO_J_ABBREV_PERIOD :
    j_abbrev_period( gw, node ) ;
    break ;
  case FUNCNO_J_ABBREV_COMMA :
    j_abbrev_comma( gw, node ) ;
    break ;
  case FUNCNO_J_ZENKAKU_EIJI :
    /* (Ѥܸ)ѻϥ⡼ɤˤ롣*/
    j_zenkaku_eiji
      ( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer, 
	node, chara ) ;
    break ;
  case FUNCNO_J_TODAY :
    /* դνϡ*/
    j_today( node ) ;
    break ;
  case FUNCNO_J_KANAINPUT_MODE_ON :
    j_kanainput_mode_on
      ( gw, &w->offthespotWin.topbuffer,
        &w->offthespotWin.lastbuffer, node ) ;
    break ;
  case FUNCNO_J_NEWLINE :
    j_newline
      ( gw, &( w->offthespotWin.xevent ), False,
	&w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer,
	node, w->offthespotWin.egg_like_newline, False,
	NULL, NULL, NULL, NULL ) ;
    break ;
  case FUNCNO_CLOSE_SKKINPUT :
    return SIW_DESTROYED ;
  case FUNCNO_VC_TOGGLE_EGGNL :
    j_delete_kanaprefix( node ) ;
    w->offthespotWin.egg_like_newline =
      ( w->offthespotWin.egg_like_newline )? False : True ;
    break ;
  case FUNCNO_SAVE_SKKINPUT_LOCAL_JISYO :
    j_delete_kanaprefix( node ) ;
    /* 񤬹Ƥ뤫ɤȽꤹ롣*/
    if( w->offthespotWin.jisyo_dirty ){
      strcpy( node->mtextbuffer, "Saving Jisyo..." ) ;
      /*skkinput_DrawScreen( gw ) ;*/
      OFFW_RedrawScreen( gw ) ;
/*      XFlush( XtDisplay( gw ) ) ;*/
      /* ι򤹤륳ХåƽФ*/
      skkinput_updateLocalJisyo() ;
      
      strcat( node->mtextbuffer, "done" ) ;
    } else {
      err_msg( node, "(No changes need to be saved)" ) ;
    }
    break ;
    /* ϥ֤Ȥˤʤ롣*/
  case FUNCNO_INVALID_CHAR :
  default :
    j_sendback_keypress( gw, &( w->offthespotWin.xevent ) ) ;
    break ;
  }
  w->offthespotWin.keybuf_use  = 0 ;
  w->offthespotWin.keybuf[ 0 ] = '\0' ;

  return SIW_PROCESSING ;
}

/*
 * ĤξνԤؿ
 */
static int do_function_by_onekey
( Widget gw, struct SKKInputNode *node, int textflag )
{
  OffthespotWinWidget w = ( OffthespotWinWidget )gw ;
  int func_no ;

  /* Ѵθ⡼ɤʤΤǤ */
  if( node->j_henkan_show_candidate_mode ){
    /* ɤʥäϤͤȤäɡĤޤΥ⡼*
     * ɤФäƤ뤫פʡ */
    do_Function_jhenkanShowCandidateMode
      ( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer,
	node, w->offthespotWin.keybuf ) ;
    /* ʸΥХåեõ롣*/
    w->offthespotWin.keybuf_use  = 0 ;
    w->offthespotWin.keybuf[ 0 ] = '\0' ;
    return SIW_PROCESSING ;

  } else if( node->j_input_by_code_or_menu_mode ){
    if( node->j_input_by_code_or_menu_mode == True ){
      do_function_j_input_by_code_or_menu_jump
	( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer,
	  node, w->offthespotWin.keybuf ) ;
      /* ʸΥХåեõ롣*/
      w->offthespotWin.keybuf_use  = 0 ;
      w->offthespotWin.keybuf[ 0 ] = '\0' ;
      return SIW_PROCESSING ; 

    } else {
      do_function_j_input_by_code_or_menu_1_jump
	( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer,
	  node, w->offthespotWin.keybuf ) ;
      /* ʸΥХåեõ롣*/
      w->offthespotWin.keybuf_use  = 0 ;
      w->offthespotWin.keybuf[ 0 ] = '\0' ;
      return SIW_PROCESSING ; 
    }
  }
  /* Ϥ줿ǽʸ򸫤ơĵǽʤǤäФ*/
  func_no = lookup_at_keymap( w->offthespotWin.keybuf, node ) ;

  /* 
   * ¿ʬʳ skk-rom-kana-rule-list åʤȤ
   * ǤʤХȥ륳ɤǤ⤽줬ȤȤȤ
   * Ϥʤʤ顣
   */
  switch( func_no ){
  case FUNCNO_J_INSERT_A :
  case FUNCNO_J_INSERT_E :
  case FUNCNO_J_INSERT_I :
  case FUNCNO_J_INSERT_O :
  case FUNCNO_J_INSERT_U :
  case FUNCNO_J_KANA_INPUT :
  case FUNCNO_J_SET_HENKAN_POINT :
    break ;
  default :
    /* ̾Ϥäꤷˤϡ⤷   *
     * rom-kana-rule-list ˥ҥåȤꤹ뤫⤷ʤ*/
    if( node->j_kana_mode ){
      if( rom_kana_rule_list_check
	  ( node, w->offthespotWin.keybuf[ 0 ] ) ){
	if( node->j_henkan_mode && !node->j_henkan_on &&
	   node->j_okurigana_mode ){
	  j_set_okurigana
	    ( gw, &w->offthespotWin.topbuffer,
	      &w->offthespotWin.lastbuffer,
	      node, node->j_okuri_chara ) ;
	}
	w->offthespotWin.keybuf_use  = 0 ;
	w->offthespotWin.keybuf[ 0 ] = '\0' ;
	return SIW_PROCESSING ;
      }
    }
    /*  oh Υå롣*/
    j_oh_check_with_controlcode
      ( node, ( ( func_no == FUNCNO_J_KEYBOARD_QUIT )? True : False ) ) ;
    break ;
  }
  /* Ϳ줿ǽ¹פޤ*/
  if( textflag ){
    return do_skkinputFunction_withtext( gw, node, func_no ) ;
  } else {
    return do_skkinputFunction_withouttext( gw, node, func_no ) ;
  }
}

/*
 * ĤξνԤؿ
 */
static int do_function_by_twokeys
( Widget gw, struct SKKInputNode *node, int textflag )
{
  OffthespotWinWidget w = ( OffthespotWinWidget )gw ;

  /* ȡΥåХåե˽񤫤Ƥ *
   * Ͼä뤳ȤˤʤäƤ롩 */
  node->mtextbuffer[ 0 ] = '\0' ;

  /* Ϥ줿Ϥ⤷ơ */
  if( lookup_at_keymap( w->offthespotWin.keybuf, node ) ==
      FUNCNO_J_SENDBACK_KEY ){
#if 0
    /* Ȥ򤷤Ƥ⡢spot_x, spot_y νäʤΤ *
     * ˤʤˤʤäƤޤover-the-spot mode ǤϽʤ褦 *
     * 롣*/
    j_sendback_keypress( gw, &( w->offthespotWin.xevent ) ) ;
#else
    /* ʾʸФʤΤǡľ*/
    w->offthespotWin.keybuf[ 0 ] = '\0' ;
    w->offthespotWin.keybuf_use  = 0 ;
    return SIW_PROCESSING ;
#endif
  } else {
    /* ơ֥ܤʣξϤʤ *
     * õʤƴŤȤޤ*/
    if( textflag ){
      return do_skkinputFunction_withtext
	( gw, node,
	  lookup_at_twokeymap( w->offthespotWin.keybuf ) ) ;
    } else {
      return do_skkinputFunction_withouttext
	( gw, node,
	  lookup_at_twokeymap( w->offthespotWin.keybuf ) ) ;
    }
      
  }
  /* ʾʸФʤΤǡľ*/
  w->offthespotWin.keybuf[ 0 ] = '\0' ;
  w->offthespotWin.keybuf_use  = 0 ;
  return SIW_PROCESSING ;
}

/*
 * Ϥ줿ʸ󤫤餽б뵡ǽ¹Ԥؿ
 */
static int do_function_by_reading_character
( Widget gw, struct SKKInputNode *node )
{
  OffthespotWinWidget w = ( OffthespotWinWidget )gw ;
  struct SKKInputNode *topbuffer = w->offthespotWin.topbuffer ;
  int textflag ;
  int ret = SIW_PROCESSING ;

#ifdef DEBUG
  fprintf( stderr, "j-prefix : %s\n", node->j_prefix ) ;
#endif

  /* ˥ɥƤ뤫ɤȽǤ롣Ѵưʤ顢 *
   * Ǥư skkinput ôʤФʤʤʳ *
   * ۤȤɤΥ֤ȤˤʤΤǡ*/
  if( topbuffer->textbuffer[ 0 ] != '\0' || 
      topbuffer->minibuffer != NULL ){
    textflag = True ;
  } else {
    textflag = False ;
  }
  /* äϡѴ饤ȤؤۤȤɤΥ뤳Ȥˤʤ롣*/
  switch( w->offthespotWin.keybuf_use ){
    /* ХϤФ*/
  case 1:
    ret = do_function_by_onekey( gw, node, textflag ) ;
    break ;
    /* ʣХȤΥϤФ*/
  case 2:
    ret = do_function_by_twokeys( gw, node, textflag ) ;
    break ;
    /* ꤨʤϤФ*/
  case 0 :
  default :
    w->offthespotWin.keybuf_use  = 0 ;
    w->offthespotWin.keybuf[ 0 ] = '\0' ;
    break ;
  }
#if 0
  /* Ϥ줿ʸѴ饤Ȥؤ٤ɤȽǤ롣*/
  if( topbuffer->j_henkan_mode || topbuffer->j_kana_mode ||
      topbuffer->j_henkan_on || topbuffer->textbuffer[ 0 ] == '\0' ||
      topbuffer->minibuffer != NULL ||
      topbuffer->mtextbuffer[ 0 ] != '\0' ){
    /* Ѵư桢ޤϡ̾ϤǤ뤫顢ʸ *
     * Ѵ饤Ȥؤޤ櫓ˤϤʤ*/
    return ret ;
  }
  /* Ѵ饤ȤظϤƤʸ롣*/
  XtCallCallbacks( gw, XtNfixNotify, ( XtPointer )topbuffer->textbuffer ) ;
  /* ƥȥХåե롣*/
  topbuffer->textbuffer[ 0 ] = '\0' ;
  /* ƬؤȰư롣*/
  topbuffer->cur_pos = 0 ;
  topbuffer->j_okurigana_start_point = -1 ;
  topbuffer->j_kana_start_point      = -1 ;
  topbuffer->j_henkan_start_point    = -1 ;
  topbuffer->j_henkan_end_point      = -1 ;
#endif
  return ret ;
}

enum {
  MODELINE_NOTHING = 0, MODELINE_HANKAKU, MODELINE_ZENKAKU,
  MODELINE_KATAKANA, MODELINE_KANA,
} ;

/*
 * Ϥ줿 skkinput Υ⡼ɥ饤󤬲ǤΤĴ٤ؿ
 */
static int skkinput_GetModelineNumber( struct SKKInputNode *node )
{
  int modeline ;
  /* ̾ϥ⡼ɤʤΡ ǤϤʤΡ */
  if( !node->j_mode ){
    /* ϥ⡼ɤʤΡ Ⱦϥ⡼ɤʤΡ */
    if( node->j_zenkaku ){
      modeline = MODELINE_ZENKAKU ;
    } else {
      modeline = MODELINE_HANKAKU ;
    }
  } else {
    /* Ҳ̾ϥ⡼ɤʤΡ ʿ̾ϥ⡼ɤʤΡ */
    if( node->j_katakana_mode ){
      modeline = MODELINE_KATAKANA ;
    } else {
      modeline = MODELINE_KANA ;
    }
  }
  return modeline ;
}

/*
 * ⡼ɥ饤褹ؿ
 */
static void OFFW_FullDrawModeLine
( Display *disp, Window win, GC roman_ngc, GC kanji_ngc, 
  struct SKKInputNode *node, int x, int y,
  int roman_width, int kanji_width, int jisyo_dirty )
{
  int modeline = skkinput_GetModelineNumber( node ) ;
  static char *modelineStrings[] = {
    "SKK:", "", "", "",
  } ;
  /* νˤäư㤦⡼ɥ饤*/
  static char *modelineStrings2[] = {
    "--", "*-",
  } ;
  /* ⡼ɥ饤ɽ( SKKΥ⡼ɽ )*/
  skkwin_jputstring
    ( disp, win, roman_ngc, kanji_ngc, 
      x, y, modelineStrings[ modeline - 1 ],
      roman_width, kanji_width ) ;
  /* ֤ι*/
  x += roman_width * 4 ;
  /* ⡼ɥ饤ɽ( ξɽ )*/
  skkwin_jputstring
    ( disp, win, roman_ngc, kanji_ngc,
      x, y, modelineStrings2[ jisyo_dirty ],
      roman_width, kanji_width ) ;
  return ;
}

/*
 * skkinput ɽؿ
 *-----
 * ϺʬԤʤ
 */
static void OFFW_FullDrawWindow
( Display *disp, Window win,
  GC roman_ngc, GC kanji_ngc, GC roman_rgc, GC kanji_rgc,
  int roman_width, int kanji_width, int font_height, int font_ascent,
  struct SKKInputNode *node, char *text, 
  int start_pos, int x, int y, int end_x, int end_y, int is_focus )
{
  int pos, chara, kana_flag, kanji_check, cursor_flag ;
  int cx, cy ;

  pos         = start_pos ;
  kana_flag   = False ;
  cursor_flag = False ;

  chara = cx = cy = 0 ;

  while( *text != '\0' ){
    /* ɤȽԤ*/
    kanji_check = 0x80 & *text ;
    /* ɽʤΤɤȽꤹ롣*/
    if( pos == node->cur_pos ){
      if( node->cur_exist ){
	skkinputDrawCursor
	  ( disp, win, roman_ngc, roman_rgc,
	    x, y, font_ascent, 
	    ( kanji_check )? kanji_width : roman_width,
	    font_height, is_focus ) ;
	cursor_flag = True ;
      }
      cx = x ;
      cy = y ;
    }
    /* ɤΰХܤʤΤǤ礦 */
    if( kanji_check && kana_flag == False ){
      kana_flag = True ;
      chara = ( unsigned char )*text ;
      /* ̤αüޤ褷ΤɤȽǤ롣*/
      if( ( x + kanji_width ) >= end_x ){
	skkwin_jputchar
	  ( disp, win, roman_ngc, kanji_ngc,
	    x, y, '\\', False ) ;
	skkwin_jputchar
	  ( disp, win, roman_ngc, kanji_ngc,
	    x + roman_width, y, '\\', False ) ;
	x = 0 ;
	y += font_height ;
	/* ̤βޤǽڤäΤɤȽǤ롣*/
	if( y >= end_y )
	  goto exit_loop ;
      }
    } else {
      /* ɤХܤʤΤǤ礦 */
      if( kana_flag ){
	chara = ( chara << 8 ) | ( ( unsigned char )*text ) ;
	/* ξ˥ɽƤΤǤ */
	if( cursor_flag ){
	  skkwin_jputchar
	    ( disp, win, roman_rgc, kanji_rgc, x, y, chara, False ) ;
	  cursor_flag = False ;
	} else {
	  skkwin_jputchar
	    ( disp, win, roman_ngc, kanji_ngc, x, y, chara, True ) ;
	}
	x += kanji_width ;
	kana_flag = False ;
      } else {
	/* ɤäνǤ*/
	if( ( x + roman_width ) >= end_x ){
	  skkwin_jputchar
	    ( disp, win, roman_ngc, kanji_ngc, x, y, '\\', False ) ;
	  x =  0 ;
	  y += font_height ;
	  /* ̤βޤǽڤäΤɤȽǤ롣*/
	  if( y >= end_y )
	    goto exit_loop ;
	}
	/* ΰ֤˥뤬ɽƤΤǤСʸȿž *
	 * 롣*/
	if( cursor_flag ){
	  skkwin_jputchar
	    ( disp, win, roman_rgc, kanji_rgc, x, y, *text, False ) ;
	  cursor_flag = False ;
	} else {
	  skkwin_jputchar
	    ( disp, win, roman_ngc, kanji_ngc, x, y, *text, True ) ;
	}
	x += roman_width ;
	if( *text == '\n' ){
	  /* ԥɤȯν*/
	  x =  0 ;
	  y += font_height ;
	  /* ̤βޤǽڤäΤɤȽǤ롣*/
	  if( y >= end_y )
	    goto exit_loop ;
	}
      }
    }
    text ++ ;
    pos ++ ;
  }
  /* Ǹޤǥ뤬ɽƤʤäΤʤ顢ǸιԤ˥ *
   * ɽ롣*/
  if( pos == node->cur_pos && node->cur_exist ){
    /* Ԥɬפꡩ */
    if( ( x + roman_width ) > end_x ){
      skkwin_jputchar
	( disp, win, roman_ngc, kanji_ngc, x, y, '\\', False ) ;
      x  = 0 ;
      y += font_height ;
    }
    skkinputDrawCursor
      ( disp, win, roman_ngc, roman_rgc, x, y, font_ascent, 
	roman_width, font_height, is_focus ) ;
    cx = x ;
    cy = y ;
  }

exit_loop:
  node->prev_cx = cx ; 
  node->prev_cy = cy ;
}
/*
 * ⡼ɥɥ֤˰ư硢ȤޤǤɽ
 * ƤޤȤʴؿ
 */
static void OFFW_resetupModeWindow( Widget gw )
{
  OffthespotWinWidget w = ( OffthespotWinWidget )gw ;
  int x, y ;

  /* Ϥ֤ˤĤƤϽ⿧(NorthWest)˸ꤷƤ
     */
  x = w->offthespotWin.status_area.x ;
  y = w->offthespotWin.status_area.y ;

  if( XtIsRealized( gw ) ){
    /* ⡼ɥɥ¸ߤƤʤääƤޤ*/
    if( !w->offthespotWin.modeshell_probe ){
      w->offthespotWin.modeshell_probe = True ;
      XtMoveWidget( w->offthespotWin.modeshell_popup, x, y ) ;
      XtPopup( w->offthespotWin.modeshell_popup, XtGrabNone ) ;
    } else {
      /* ɽ֤ν򤹤롣*/
      XtMoveWidget
	( w->offthespotWin.modeshell_popup, x, y ) ;
      XClearWindow
	( XtDisplay( gw ),
	  XtWindow( w->offthespotWin.modeshell_canvas ) ) ;
    }
    /* ⡼ɥ饤ɽ롣*/
    XtVaSetValues
      ( w->offthespotWin.modeshell_canvas,
        XtNredrawRequest, True, NULL ) ;
  }
  return ;
}

/*
 * skkinput β̤򤤤ľؿ
 *-----
 * ̤礭ѹʤɤԤ줿ˤϤδؿƤФ뤳Ȥ
 * ʤ롣
 */
static void OFFW_RedrawScreen( Widget gw )
{
  OffthespotWinWidget w = ( OffthespotWinWidget )gw ;

  /* 褵롣*/
  if( w->offthespotWin.canvas_probe )
    XtVaSetValues
      ( w->offthespotWin.canvas, XtNredrawRequest, True, NULL ) ;
  /* ⡼ɥɥɽ롣*/
  OFFW_resetupModeWindow( gw ) ;
  /* mini-buffer ɽ롣*/
  OFFW_ConfigureMinibuffer( gw ) ;
  return ;
}

/* ǡΰ֤̳˽ФΤɤȽǤʤФʤ *
 * ʤ*/
static void OFFW_ConfigureMinibufferPosition
( Widget gw, int *rx, int *ry )
{
  OffthespotWinWidget w = ( OffthespotWinWidget )gw ;
  XWindowAttributes xwa ;
  int x, y, mwidth, mheight ;
  int win_gravity ;
  XSizeHints sizehints ;

  win_gravity = NorthWestGravity ;

  /* Root Window 礭Ƥ*/
  XGetWindowAttributes
    ( XtDisplay( gw ), RootWindowOfScreen( XtScreen( gw ) ), &xwa ) ;
      
  /* ⤦äȤȤɬפꡣ*/
  y = w->offthespotWin.client_y + w->offthespotWin.focus_offset_y + 
    w->offthespotWin.client_area.y +
    w->offthespotWin.client_area.height +
    w->offthespotWin.minibuffer_popup->core.border_width ;
  x = w->offthespotWin.client_x + w->offthespotWin.focus_offset_x ;

  mheight = w->offthespotWin.minibuffer_popup->core.border_width * 2 +
    ( ( w->offthespotWin.change_minibuffer_font )?
      w->offthespotWin.font_height : w->offthespotWin.mfont_height ) ;
  mwidth = w->offthespotWin.minibuffer_popup->core.border_width * 2 +
    ( ( w->offthespotWin.change_minibuffer_font )?
      w->offthespotWin.roman_width : w->offthespotWin.mroman_width ) *
    w->offthespotWin.minibuf_width ;

  if( y + mheight > xwa.height ){
    y = w->offthespotWin.client_y - mheight -
      w->offthespotWin.minibuffer_popup->core.border_width * 2 ;
    if( y < 0 ){
      y = xwa.height - mheight -
	w->offthespotWin.minibuffer_popup->core.border_width * 2 ;
    }
    if( y < 0 ){
      y = 0 ;
    } else {
      win_gravity = SouthWestGravity ;
    }
  }
  if( x + mwidth > xwa.width ){
    x = xwa.width - mwidth ;
    if( x < 0 ){
      x = 0 ;
    } else {
      if( win_gravity == NorthWestGravity ){
	win_gravity = NorthEastGravity ;
      } else {
	win_gravity = SouthEastGravity ;
      }
    }
  } else if( x < 0 ){
    x = 0 ;
  }
  /* Window Manager ˥ҥȤäƤ롣XSetWMNormalHints * 
   * ʬ񴹤ʤ褦ʤΤǡ hints ɤߤȤäƤ麹*
   * ؤȤˡȤʤФʤʤ*/
  sizehints.flags = PWinGravity ;
  sizehints.win_gravity = win_gravity ;
  XChangeWMNormalHints
    ( XtDisplay( gw ),
      XtWindow( w->offthespotWin.minibuffer_popup ),
      &sizehints ) ;
  *rx = x ;
  *ry = y ;
  return ;
}

/*
 * ߥ˥Хåեɥ֡礭Ԥؿ
 *----
 * 礭ϼ¤ꤷƤޤ󡣺ǽꤷǤ̤˥ߥ
 * Хåե򲿽֤ɤΤʡĤȽǤ˻Ȥ櫓Ǥ
 */
static void OFFW_ConfigureMinibuffer( Widget gw )
{
  OffthespotWinWidget w = ( OffthespotWinWidget )gw ;
  struct SKKInputNode *node = w->offthespotWin.topbuffer ;
  struct SKKInputNode *mNode = w->offthespotWin.lastbuffer ;

  if( mNode == node ){
    /* ɽ٤ƥȤ̵äˤϡ*/
    if( node->mtextbuffer[ 0 ] == '\0' ){
      /* УϣХåפ֤ä顢Ĥ롣*/ 
      if( w->offthespotWin.minibuffer_probe ){
	XtPopdown( w->offthespotWin.minibuffer_popup ) ;
	w->offthespotWin.minibuffer_probe = False ;
      }
      return ;
    }
  }
  /* ߥ˥ХåեϵƤʤΡ ƤʤΤä鵯ɬ *
   * 衣*/
  if( !w->offthespotWin.minibuffer_probe ){
    int x, y ;
    OFFW_ConfigureMinibufferPosition( gw, &x, &y ) ;

    /* ꤵ줿֤˥ߥ˥Хåեư롣*/
    XtMoveWidget
      ( w->offthespotWin.minibuffer_popup, x, y ) ;
    /* Popup 롣*/
    XtPopup( w->offthespotWin.minibuffer_popup, XtGrabNone ) ;
    w->offthespotWin.minibuffer_probe = True ;
  }
  /* Хľ褦׵Ф*/
  XtVaSetValues
    ( w->offthespotWin.minibuffer_canvas, 
      XtNredrawRequest, True, NULL ) ;
  return ;
}    

static void Canvas_RedisplayCallback
( Widget gw, caddr_t client, caddr_t caller )
{
  OffthespotWinWidget w = ( OffthespotWinWidget )client ;
  int linenum, cur_line, maxline, spos, sty, edy ;
  unsigned char *ptr ;
  struct SKKInputNode *node = w->offthespotWin.topbuffer ;

  /* Canvas  popup ƤʤеѲ롣popup ޤǤ˥ե
     νʤɤ򤹤Τǡʲν¹ԤƤϺ櫓Ǥ롣*/
  if( !w->offthespotWin.canvas_probe )
    return ;

  XClearWindow
    ( XtDisplay( ( Widget )w ), XtWindow( w->offthespotWin.canvas ) ) ;
  /* ɽǽԿ롣*/
  maxline = w->offthespotWin.client_area.height /
    w->offthespotWin.font_height ;
  /* ߡƥȤϲԤޤɽʤФʤʤΤ򻻽Ф롣*/
  linenum = skkinput_GetLineNum
    ( node->textbuffer, w->offthespotWin.roman_width,
      w->offthespotWin.kanji_width, w->offthespotWin.client_area.width,
      node->cur_pos, &cur_line ) ;
  /* ɽǽԿĶƤν֤ϰϤ *
   * ǰֺǽιԤֹ椬Ǥ⾮ʤ褦ꤹ롣*/
  if( linenum >= maxline && cur_line >= maxline ){
    int startline = cur_line - maxline + 1 ;
    /* ꤵ줿꤫ɽʤФʤʤΤǡΰ֤򻻽Ф롣*/
    spos = skkinput_FindStartLine
      ( node->textbuffer, w->offthespotWin.roman_width,
	w->offthespotWin.kanji_width,
	startline, w->offthespotWin.client_area.width ) ;
    ptr = node->textbuffer + spos ;
  }  else {
    spos = 0 ;
    /* ˰ֺǽʸɽǽǤ롣*/
    ptr = node->textbuffer ;
  }    
  sty = w->offthespotWin.font_ascent ;
  edy = sty + maxline * w->offthespotWin.font_height ;
  /* Window  buffer ʸɽ롣*/
  OFFW_FullDrawWindow
    ( XtDisplay( ( Widget )w ), XtWindow( w->offthespotWin.canvas ),
      w->offthespotWin.roman_ngc, w->offthespotWin.kanji_ngc,
      w->offthespotWin.roman_rgc, w->offthespotWin.kanji_rgc,
      w->offthespotWin.roman_width, w->offthespotWin.kanji_width,
      w->offthespotWin.font_height, w->offthespotWin.font_ascent,
      node, ptr, spos, 0, sty, w->offthespotWin.client_area.width,
      edy, w->offthespotWin.is_focus ) ;
  return ;
}

/*
 * δؿϸߤξǤκ褷ޤpopup/popdown ʤɤ
 * ƤФäƤƤ뤳Ȥˤޤꥢ꤫ʤ Ǥ⡢
 * ѲڤäưͿΤϿ(Ĥޤ offthespotWinWidget)ʤΤ
 * 顢ҶǤȤ餻äƤΤϡġo
 */
static void Minibuffer_RedisplayCallback
( Widget gw, caddr_t client, caddr_t caller )
{
  OffthespotWinWidget w = ( OffthespotWinWidget )client ;
  struct SKKInputNode *mNode ;
  struct SKKInputNode *node = w->offthespotWin.topbuffer ;

  if( !w->offthespotWin.minibuffer_probe )
    return ;

  XClearWindow( XtDisplay( gw ), XtWindow( gw ) ) ;

  /* mini-buffer ɽ롣*/
  mNode = w->offthespotWin.lastbuffer ;

  if( mNode == node ){
    /* ɽ٤ƥȤ̵äˤϡ*/
    if( node->mtextbuffer[ 0 ] == '\0' )
      return ;

    /* ĤߤäȤʤɬɽ˽ФƤ褦ˤ롣*/
    XRaiseWindow
      ( XtDisplay( gw ), XtWindow( gw ) ) ;
    if( w->offthespotWin.change_minibuffer_font ){
      /* ߥ˥Хåեɽ롣*/
      skkwin_jputstring
	( XtDisplay( gw ), XtWindow( gw ), 
	  w->offthespotWin.roman_ngc, w->offthespotWin.kanji_ngc,
	  0, w->offthespotWin.font_ascent, node->mtextbuffer,
	  w->offthespotWin.roman_width, w->offthespotWin.kanji_width ) ;
    } else {
      skkwin_jputstring
	( XtDisplay( gw ), XtWindow( gw ), 
	  w->offthespotWin.mroman_ngc, w->offthespotWin.mkanji_ngc,
	  0, w->offthespotWin.mfont_ascent, node->mtextbuffer,
	  w->offthespotWin.mroman_width, w->offthespotWin.mkanji_width ) ;
    }
  } else {
    /* ĤߤäȤʤɬɽ˽ФƤ褦ˤ롣*/
    XRaiseWindow
      ( XtDisplay( gw ), XtWindow( gw ) ) ;

    if( mNode->mtextbuffer[ 0 ] != '\0' ){
      if( w->offthespotWin.change_minibuffer_font ){
	skkwin_jputstring
	  ( XtDisplay( gw ), XtWindow( gw ),
	    w->offthespotWin.roman_ngc, w->offthespotWin.kanji_ngc,
	    0, w->offthespotWin.font_ascent, mNode->mtextbuffer,
	    w->offthespotWin.roman_width,
	    w->offthespotWin.kanji_width ) ;
      } else {
	skkwin_jputstring
	  ( XtDisplay( gw ), XtWindow( gw ),
	    w->offthespotWin.mroman_ngc, w->offthespotWin.mkanji_ngc,
	    0, w->offthespotWin.mfont_ascent, mNode->mtextbuffer,
	    w->offthespotWin.mroman_width,
	    w->offthespotWin.mkanji_width ) ;
      }
    } else {
      unsigned char *toptext ;
      int toppos ;
      XWindowAttributes xwa ;
      /* ǲˤʤ뤫ĲȴФƤ*/
      XGetWindowAttributes
	( XtDisplay( gw ), XtWindow( gw ), &xwa ) ;

      if( w->offthespotWin.change_minibuffer_font ){
	/* Window  buffer ʸɽ롣*/
	OTSW_CalcTopPositionOfBuffer
	  ( mNode->textbuffer, 0, mNode->cur_pos, xwa.width,
	    w->offthespotWin.roman_width,
	    w->offthespotWin.kanji_width,
	    &toptext, &toppos ) ;
	OTSW_FullDrawTopBufferTopLine
	  ( XtDisplay( gw ), XtWindow( gw ),
	    w->offthespotWin.roman_ngc, w->offthespotWin.kanji_ngc,
	    w->offthespotWin.roman_rgc, w->offthespotWin.kanji_rgc,
	    toptext, toppos,
	    w->offthespotWin.roman_width, w->offthespotWin.kanji_width,
	    w->offthespotWin.font_ascent, w->offthespotWin.font_height,
	    xwa.width, True,
	    mNode->cur_pos, mNode->cur_exist, 
	    w->offthespotWin.is_focus ) ;
      } else {
	/* Window  buffer ʸɽ롣*/
	OTSW_CalcTopPositionOfBuffer
	  ( mNode->textbuffer, 0, mNode->cur_pos, xwa.width,
	    w->offthespotWin.mroman_width,
	    w->offthespotWin.mkanji_width,
	    &toptext, &toppos ) ;
	OTSW_FullDrawTopBufferTopLine
	  ( XtDisplay( gw ), XtWindow( gw ),
	    w->offthespotWin.mroman_ngc, w->offthespotWin.mkanji_ngc,
	    w->offthespotWin.mroman_rgc, w->offthespotWin.mkanji_rgc,
	    toptext, toppos,
	    w->offthespotWin.mroman_width, w->offthespotWin.mkanji_width,
	    w->offthespotWin.mfont_ascent, w->offthespotWin.mfont_height,
	    xwa.width, True,
	    mNode->cur_pos, mNode->cur_exist, 
	    w->offthespotWin.is_focus ) ;
      }
    }
  }
  return ;
}

static void Modeshell_RedisplayCallback
( Widget gw, caddr_t client, caddr_t caller )
{
  OffthespotWinWidget w = ( OffthespotWinWidget )client ;
  struct SKKInputNode *node = w->offthespotWin.topbuffer ;

  /* ⡼ɥɥ¸ߤƤʤääƤޤ*/
  if( !w->offthespotWin.modeshell_probe )
    return ;
  /* ľΤ˾õƤ*/
  XClearWindow( XtDisplay( gw ), XtWindow( gw ) ) ;
  /* ⡼ɥ饤ɽ롣ʬɽľбͽǤϤ롣*/
  OFFW_FullDrawModeLine
    ( XtDisplay( gw ), XtWindow( gw ),
      w->offthespotWin.roman_ngc, w->offthespotWin.kanji_ngc,
      node, 0, w->offthespotWin.font_ascent,
      w->offthespotWin.roman_width, w->offthespotWin.kanji_width,
      w->offthespotWin.jisyo_dirty ) ;
  return ;
}

/*
 * Canvas Widget ˸ƤӽФ륳Хåؿ
 */
static void Canvas_DestroyCallback
( Widget gw, caddr_t client, caddr_t caller )
{
  XtRemoveAllCallbacks( gw, XtNredrawNotify ) ;
  XtRemoveAllCallbacks( gw, XtNdestroyNotify ) ;
  return ;
}

static void OFFW_wmMessageCloseCallback
( Widget gw, caddr_t client, caddr_t caller )
{
  OffthespotWinWidget w = ( OffthespotWinWidget )client ;
  struct SKKInputNode *node ;
  unsigned char keybuf[ 3 ] ;
  int keybuf_use ;

  node = ( w->offthespotWin.lastbuffer->cur_exist )?
    w->offthespotWin.lastbuffer : w->offthespotWin.topbuffer ;

  strcpy( keybuf, w->offthespotWin.keybuf ) ;
  keybuf_use = w->offthespotWin.keybuf_use ;
  
  w->offthespotWin.keybuf[ 0 ] = 0x07 ;
  w->offthespotWin.keybuf[ 1 ] = '\0' ;
  w->offthespotWin.keybuf_use  = 1 ;

  if( node->j_henkan_show_candidate_mode ){
    do_Function_jhenkanShowCandidateMode
      ( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer,
	node, w->offthespotWin.keybuf ) ;
  } else if( node->j_input_by_code_or_menu_mode ){
    if( node->j_input_by_code_or_menu_mode == True ){
      do_function_j_input_by_code_or_menu_jump
	( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer,
	  node, w->offthespotWin.keybuf ) ;
    } else {
      do_function_j_input_by_code_or_menu_1_jump
	( gw, &w->offthespotWin.topbuffer, &w->offthespotWin.lastbuffer,
	  node, w->offthespotWin.keybuf ) ;
    }
  } else if( w->offthespotWin.topbuffer !=
	     w->offthespotWin.lastbuffer ){
    j_keyboard_quit
      ( gw, &w->offthespotWin.topbuffer,
	&w->offthespotWin.lastbuffer, node ) ;
  } else {
    node->mtextbuffer[ 0 ] = '\0' ;
  }
  strcpy( w->offthespotWin.keybuf, keybuf ) ;
  w->offthespotWin.keybuf_use = keybuf_use ;
  OFFW_RedrawScreen( ( Widget )w ) ;
  return ;
}

static void OFFW_wmShellDestroyCallback
( Widget gw, caddr_t client, caddr_t caller )
{
  /* ƤΥХåؿ˴Ƥ*/
  XtRemoveAllCallbacks( gw, XtNwmcloseNotify ) ;
  XtRemoveAllCallbacks( gw, XtNdestroyNotify ) ;
  return ;
}
