/* # skkinput (Simple Kana-Kanji Input)
 * SkkInputP.h --- Private Header file for SkkInputWidget.
 * This file is part of skkinput.
 * Copyright (C) 1997
 * Takashi SAKAMOTO (sakamoto@yajima.kuis.kyoto-u.ac.jp)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with skkinput; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#ifndef OffWinP_h
#define OffWinP_h

#include "commondef.h"
#include "buffers.h"
#include "skkkey.h"
#include "attrs.h"
#include "OffWin.h"
#include <X11/CoreP.h>

typedef struct {
  Pixel		puppixel ;	/* foreground pixel */
  /* ѤƤեȡΤʤ */
  XFontStruct	*fs_roman, *fs_default_roman, *fs_minibuf_roman ;
  XFontStruct	*fs_kanji, *fs_default_kanji, *fs_minibuf_kanji ;
  /* ̤褹ΤѤ GC */
  GC		roman_ngc, kanji_ngc, mroman_ngc, mkanji_ngc ;
  GC		roman_rgc, kanji_rgc, mroman_rgc, mkanji_rgc ;
  /* եȤξȴФƤΤϤɤΤǡ*/
  int		font_height, font_ascent ;
  int		roman_width, kanji_width ;
  int		mfont_height, mfont_ascent ;
  int		mroman_width, mkanji_width ;
  Dimension	minibuf_width ;
  /* ȿžɽ뤫ݤ */
  Boolean	reverse_video ;
  /* kterm ʤɤΥեȤΥѹˤߥ˥ХåեΥեȥ *
   * ⽤뤫ݤ*/
  Boolean	change_minibuffer_font ;
  Colormap	colormap ;
  Pixel		foreground, background ;
  Pixel		oforeground, obackground ;
  int		clearMinibuffer ;

  Window	client_window ;
  /* եäƤ륦ɥ*/
  Window	focus_window ;
  /* ˥ޥ뤬ȥեƤȽǤ뺬 *
   * Ȥʤ륦ɥ*/
  Window	input_focus_window ;
  Window	probe_window ;
  /* ƥȤɽϤ٤(եɥǤ *
   * а֤Ǥ롣*/
  Position	spot_x, spot_y ;
  /* Ѵ饤Ȥɽΰ衣*/
  XRectangle	client_area ;
  /* Ѵ饤ȤΥơꥢΰ衣*/
  XRectangle	status_area ;
  /* Ѵ饤ȤΥ롼ȥɥǤа֡ĤȤȤˤ *
   * Ƥ*/
  Position	focus_offset_x, focus_offset_y ;
  Position	client_x, client_y ;
  unsigned long attribute_mask ;
  int		conversion_set_focus, conversion_unset_focus ;

  /* ʸ(Хåե)ɽΤ˻Ȥ WindowĹ򣳤 *
   * Ȥ߹碌ˤʤΤǡ//λɬפˤʤ롣*/
  Widget	canvas_popup, canvas ;
  int		canvas_probe ;

  /* ߤδϥ⡼ɤɽ륦ɥ*/
  Widget	minibuffer_popup, minibuffer_canvas ;
  int		minibuffer_probe ;
  Widget	modeshell_popup, modeshell_canvas ;
  int		modeshell_probe ;

  /* ؤΥ٥Ȥ򵭲ơĥ򲡤᤹ΤѤ롣*/
  XEvent	xevent ;
  /* ϤѤʬ*/
  unsigned char	keybuf[ 3 ] ;
  int		keybuf_use ;
  /* åȥץ⡼ɤݤ*/
  int		chat_adapter ;
  /* ɽ֡νɬפݤ*/
  int		iposflag ;
  int		egg_like_newline ;
  /* եäƤ뤫ɤ*/
  int		is_focus ;
  int		jisyo_dirty ;
  /* åȥХåե*/
  unsigned char	cutbuffer[ TEXTBUFSIZE ] ;

  /* 饤ȤƤѿ*/
  struct ConvAttrsMesg *camsg ;

  /* Callback Ĥʤ˰դġ*/
  XtCallbackList endcallback ;	/* Widget ˲ѡ*/
  XtCallbackList fixcallback ;	/* ѴʸΤѡ*/
  XtCallbackList keybackcallback ;	/* 򲡤᤹Τѡ*/

  /* ѴѤХåեԽȤϤΥХåեǹԤ롣*/
  struct SKKInputNode *topbuffer ;
  /* ֺǸΥХåեminibuffer ǤֺǿΤΤǻ *
   * 롣*/
  struct SKKInputNode *lastbuffer ;

} OffthespotWinPart ;

/* դ뤤󤹤󤹡 */
typedef struct _OffthespotWinRec {
  CorePart 		core ;
  OffthespotWinPart	offthespotWin ;
} OffthespotWinRec ;

/* New fields for the My widget class record */
typedef struct {
  int dummy ;
} OffthespotWinClassPart ;

/* դ뤯餹 */
typedef struct _OffthespotWinClassRec {
  CoreClassPart			core_class ;
  OffthespotWinClassPart	offthespotWin_class ;
} OffthespotWinClassRec ;

/* 餹ݤ󤿡 */
extern OffthespotWinClassRec	offthespotWinClassRec ;

#endif
