/* # skkinput (Simple Kana-Kanji Input)
 * SkkInputP.h --- Private Header file for SkkInputWidget.
 * This file is part of skkinput.
 * Copyright (C) 1997
 * Takashi SAKAMOTO (sakamoto@yajima.kuis.kyoto-u.ac.jp)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with skkinput; see the file COPYING.  If not, write to
 * the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#ifndef SeparateWinP_h
#define SeparateWinP_h

#include "commondef.h"
#include "buffers.h"
#include "skkkey.h"
#include "SeparateWin.h"
#include "HistMgr.h"
#include <X11/CoreP.h>

typedef struct {
  Pixel		puppixel ;	/* foreground pixel */
  /* ѤƤեȡΤʤ */
  XFontStruct	*fs_roman ;
  XFontStruct	*fs_kanji ;
  /* ̤褹ΤѤ GC */
  GC		roman_ngc, kanji_ngc ;
  GC		roman_rgc, kanji_rgc ;
  /* եȤξȴФƤΤϤɤΤǡ*/
  int		font_height, font_ascent ;
  int		roman_width, kanji_width ;
  /* ȿžɽ뤫ݤ */
  Boolean	reverse_video ;
  /* Shift + Space Ĥ뤫ɤ*/
  Boolean	compatible_close_skkinputkey ;
  int		clearMinibuffer ;
  /* ľ()ΤѰդƤ*/
  Window	probe_window ;

  /* */
  Widget	canvas, canvas_popup ;
  int		canvas_probe ;
  int		conversion_set_focus, conversion_unset_focus ;

  /* ؤΥ٥Ȥ򵭲ơĥ򲡤᤹ΤѤ롣*/
  XEvent xevent ;
  /* ϤѤʬ*/
  unsigned char keybuf[ 3 ] ;
  int keybuf_use ;
  /* åȥץ⡼ɤݤ*/
  int chat_adapter ;
  int egg_like_newline ;
  /* եäƤ뤫ɤ*/
  int is_focus ;
  int jisyo_dirty ;
  /* åȥХåե*/
  unsigned char cutbuffer[ TEXTBUFSIZE ] ;

  /* ϤФƤҥȥХåեäʸꤷ */
  /* ƱϤäɤפɬסĺɬפɤ */
  /* ʬʤɡ*/
  unsigned char *historybuffer ;
  unsigned char histcurbackbuffer[ TEXTBUFSIZE ] ;
  int hist_start, hist_end, hist_cur ;
  /* μϤ˻Ȥѿ(ݥ)*/
  HistoryListNode *historyAttribute ;

  /* ʬѤХåե빽äƤ*/
  unsigned char pwrite_string[ TEXTBUFSIZE ] ;
  unsigned char pmtextbuffer[ TEXTBUFSIZE ] ;
  int prev_eggnl ;
  int prev_modeline ;
  int prev_jisyo_dirty ;
  int prev_chat_adapter ;

  /* Callback Ĥʤ˰դġ*/
  XtCallbackList endcallback ;	/* Widget ˲ѡ*/
  XtCallbackList fixcallback ;	/* ѴʸΤѡ*/
  XtCallbackList keybackcallback ;	/* 򲡤᤹Τѡ*/
  /* ѴѤХåեԽȤϤΥХåեǹԤ롣*/
  struct SKKInputNode *topbuffer ;
  /* ֺǸΥХåեminibuffer ǤֺǿΤΤǻ *
   * 롣*/
  struct SKKInputNode *lastbuffer ;

} SeparateWinPart ;

/* դ뤤󤹤󤹡 */
typedef struct _SeparateWinRec {
  CorePart 		core ;
  SeparateWinPart	separateWin ;
} SeparateWinRec ;

/* New fields for the My widget class record */
typedef struct {
  int dummy ;
} SeparateWinClassPart ;

/* դ뤯餹 */
typedef struct _SeparateWinClassRec {
  CoreClassPart		core_class ;
  SeparateWinClassPart	separateWin_class ;
} SeparateWinClassRec ;

/* 餹ݤ󤿡 */
extern SeparateWinClassRec separateWinClassRec ;

#endif
