#include <stdio.h>
#include <X11/Xos.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>

#include "SubwindowShellP.h"

/*
 * ץȥ
 */
static void SBWS_Initialize 
( Widget greq, Widget gnew, ArgList args, Cardinal *num_args ) ;
static void SBWS_Realize
( Widget gw, XtValueMask *valuemask, XSetWindowAttributes *attr ) ;
static Boolean SBWS_SetValues
( Widget current, Widget request, Widget new,
  ArgList args, Cardinal *num_args ) ;
static void SBWS_GetParentInfo( Widget gw ) ;
static void SBWS_FocusInEventHandler
( Widget gw, XEvent *xevent, String *params, Cardinal *num_params ) ;
     
static XtActionsRec subwindowshellActionsTbl [] = {
  { "focus-in-eventhandler",   SBWS_FocusInEventHandler },
};

static char defaultSubwindowshellTranslations[] =  
"<Enter>:    focus-in-eventhandler()\n\
 <FocusIn>:  focus-in-eventhandler()\n" ;

#define offset(field)  XtOffsetOf( SubwindowShellRec, subwindowShell.field)
#define goffset(field) XtOffsetOf( WidgetRec, shell.field )

static XtResource SBWS_resources[] = {
  { XtNparentWindow, XtCParentWindow, XtRImmediate, sizeof( Window ),
    offset(parentWindow), XtRImmediate, ( XtPointer )None },
  { XtNprobeWindow, XtCProbeWindow, XtRImmediate, sizeof( Window ),
    offset(probeWindow), XtRImmediate, ( XtPointer )None },
} ;

#undef offset
#undef goffset

SubwindowShellClassRec subwindowShellClassRec = {
  { /* core fields */
    /* superclass		*/	(WidgetClass) &overrideShellClassRec,
    /* class_name		*/	"SubwindowShell",
    /* widget_size		*/	sizeof( SubwindowShellRec ),
    /* class_initialize		*/	NULL,
    /* class_part_initialize	*/	NULL,
    /* class_inited		*/	FALSE,
    /* initialize		*/	SBWS_Initialize,
    /* initialize_hook		*/	NULL,
    /* realize			*/	SBWS_Realize,
    /* actions			*/	subwindowshellActionsTbl,
    /* num_actions		*/	XtNumber( subwindowshellActionsTbl ),
    /* resources		*/	SBWS_resources,
    /* num_resources		*/	XtNumber( SBWS_resources ),
    /* xrm_class		*/	NULLQUARK,
    /* compress_motion		*/	TRUE,
    /* compress_exposure	*/	TRUE,
    /* compress_enterleave	*/	TRUE,
    /* visible_interest		*/	FALSE,
    /* destroy			*/	NULL,
    /* resize			*/	XtInheritResize,
    /* expose			*/	XtInheritExpose,
    /* set_values		*/	SBWS_SetValues,
    /* set_values_hook		*/	NULL,
    /* set_values_almost	*/	XtInheritSetValuesAlmost,
    /* get_values_hook		*/	NULL,
    /* accept_focus		*/	NULL,
    /* version			*/	XtVersion,
    /* callback_private		*/	NULL,
    /* tm_table			*/	defaultSubwindowshellTranslations,
    /* query_geometry		*/	XtInheritQueryGeometry,
    /* display_accelerator	*/	XtInheritDisplayAccelerator,
    /* extension		*/	NULL
  },
  { /* Composite */
    /* geometry_manager		*/	XtInheritGeometryManager,
    /* change_managed		*/	XtInheritChangeManaged,
    /* insert_child		*/	XtInheritInsertChild,
    /* delete_child		*/	XtInheritDeleteChild,
    /* extension		*/	NULL
  },
  { /* shell fields */
    /* extension		*/	NULL
  },
  { /* overrideShell fields */
    /* extension		*/	NULL
  },
  { /* SubwindowShell fields */
    /* empty			*/	0
  }
};

WidgetClass subwindowShellWidgetClass =
( WidgetClass )&subwindowShellClassRec ;

static void SBWS_Initialize 
( Widget greq, Widget gnew, ArgList args, Cardinal *num_args )
{
#if 0
  SubwindowShellWidget w = ( SubwindowShellWidget )gnew ;
  w->subwindowShell.parentWindow = None ;
#endif
  return ;
}

static void SBWS_Realize
( Widget gw, XtValueMask *valuemask, XSetWindowAttributes *attr )
{
  SubwindowShellWidget w = ( SubwindowShellWidget )gw ;
  Window original_parent ;
  
  if( w->subwindowShell.parentWindow == None){
    w->subwindowShell.parentWindow = w->core.screen->root ;
  } else {
    SBWS_GetParentInfo( gw ) ;
  }
  original_parent = w->core.screen->root ;
  w->core.screen->root = w->subwindowShell.parentWindow ;

  ( *subwindowShellWidgetClass->core_class.superclass->core_class.realize)
    (gw, valuemask, attr) ;

  w->core.screen->root = original_parent ;
  return ;
}

static Boolean SBWS_SetValues
( Widget current, Widget request, Widget new,
  ArgList args, Cardinal *num_args )
{
  SubwindowShellWidget curw = ( SubwindowShellWidget )current ;
  SubwindowShellWidget reqw = ( SubwindowShellWidget )request ;
  SubwindowShellWidget neww = ( SubwindowShellWidget )new ;

  if( curw->subwindowShell.parentWindow !=
     reqw->subwindowShell.parentWindow ){
    if( !XtIsRealized( new ) ){
      /* realize ʤѹϸ*/
      neww->subwindowShell.parentWindow =
	reqw->subwindowShell.parentWindow ;
    } else {
      /* ١realize Ƥޤä顢ϤФʤ*/
      neww->subwindowShell.parentWindow =
	reqw->subwindowShell.parentWindow =
	  curw->subwindowShell.parentWindow ;
    }
  }
  return FALSE ;
}

static void SBWS_GetParentInfo( Widget gw )
{
  SubwindowShellWidget w = ( SubwindowShellWidget )gw ;
  XWindowAttributes xwa ;

  XGetWindowAttributes
    ( XtDisplay( gw ), w->subwindowShell.parentWindow, &xwa ) ;

  w->core.screen   = xwa.screen ;
  w->core.colormap = xwa.colormap ;
  w->core.depth    = xwa.depth ;
  w->shell.visual  = xwa.visual ;
  return ;
}

static void SBWS_FocusInEventHandler
( Widget gw, XEvent *xevent, String *params, Cardinal *num_params )
{
  SubwindowShellWidget w = ( SubwindowShellWidget )gw ;
  Window win ;

  win = ( w->subwindowShell.probeWindow != None )? 
    w->subwindowShell.probeWindow : w->subwindowShell.parentWindow ;
  XSetInputFocus
    ( XtDisplay( gw ), win, RevertToNone, CurrentTime ) ;
  return ;
}
