#include <stdio.h>

#define CS96	0x100	/* 96chars CS */
#define MBCS	0x200	/* Multibyte CS */

/* convJWStoCT -- Japanese Wide Character String -> COMPOUND_TEXT */
int convJWStoCT( char *str, unsigned char *xstr, int jisroman )
{
  int	g0, g1 ;
  int	n ;
  int	g0cs ;
	
  g0cs = jisroman ? 'J' : 'B';
  g0 = 'B' ;
  g1 = CS96|'A' ;
	
  /*
   * G0, G1 ϼΤ褦˻Ȥʬ
   *  G0: ASCII / JIS-ROMAN
   *  G1:  / 
   */
#ifdef DEBUG
  fprintf( stderr, "CONV : " ) ;
#endif
  n = 0 ;
  while( *str != '\0' ){
#ifdef DEBUG
    fprintf( stderr, "( %d )->", n ) ;
#endif
    if( ( *str ) & 0x80 ){
      /*  */
      if( g1 != ( MBCS|'B' ) ){
	if( xstr != NULL ){
	  *xstr ++ = 0x1b ;
	  *xstr ++ = 0x24 ;
	  *xstr ++ = ')';
	  *xstr ++ = 0x42 ;
	}
	n += 4 ;
	g1 = MBCS|'B' ;
      }
      if( xstr != NULL ){
	*xstr ++ = ( *str ++ ) & 0xff ;
	*xstr ++ = *( str ++ ) & 0xff ;
      } else {
	str ++ ;
	str ++ ;
      }
      n += 2 ;
      continue ;
    } else {
      /* ASCII or C0 */
      if( *str < ' '){
	/* C0 */
	if( *str == '\t' || *str == '\n') {
	  if ( xstr != NULL ){
	    *xstr ++ = *str ;
	  }
	  n++ ;
	}
	str ++ ;
	continue ;
      }
      if( g0 != g0cs ){
	if( xstr != NULL ){
	  *xstr++ = 0x1b ;
	  *xstr++ = '(' ;
	  *xstr++ = g0cs ;
	}
	n += 3 ;
	g0 = g0cs ;
      }
      if ( xstr != NULL ){
	*xstr ++ = ( *str ) & 0x7f ;
      }
      str ++ ;
      n ++ ;
      continue ;
    }
  }
  if( xstr != NULL ){
    *xstr = '\0' ;
  }
  n ++ ;
#ifdef DEBUG
  fprintf( stderr, "\n" ) ;
#endif
  return n ;
}
