#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>

#include "commondef.h"
/*
 * skkinput λꤵ줿˥饯ɽؿ
 *----
 * flag ϽŤ͹碌Ԥɤɽ˴ط롣
 * ȿžɽ򤹤뤫ɤϡgc ǻꤹ뤳ȤˤʤäƤ롣
 */
void skkwin_jputchar
( Display *disp, Window win, GC roman_gc, GC kanji_gc,
  int x, int y, int chara, int flag )
{
  char buffer[ 3 ] ;

  if( chara > 0x100 ){
    buffer[ 0 ] = ( chara & 0x07F00 ) >> 8 ;
    buffer[ 1 ] = ( chara & 0x0007F ) ;
    buffer[ 2 ] = '\0' ;
    /* ʸɽ*/
    if( flag ){
      XDrawString16
	( disp, win, kanji_gc, x, y, ( XChar2b *)buffer, 1 ) ;
    } else {
      XDrawImageString16
	( disp, win, kanji_gc, x, y, ( XChar2b *)buffer, 1 ) ;
    }
  } else {
    buffer[ 0 ] = chara ;
    buffer[ 1 ] = '\0' ;
    if( flag ){
      XDrawString
	( disp, win, roman_gc, x, y, buffer, 1 ) ;
    } else {
      XDrawImageString
	( disp, win, roman_gc, x, y, buffer, 1 ) ;
    }
  }
  return ;
}

/*
 * skk window ʸõؿ
 *----
 * x, y Ϻɸ
 */
void skkwin_jerase
( Display *disp, Window win, GC gc, int x, int y,
  int font_ascent, int width, int height )
{
  XFillRectangle
    ( disp, win, gc, x, y - font_ascent, width, height ) ;
  return ;
}

/*
 * skkinput λꤵ줿˥饯ɽؿ
 *----
 * flag ϽŤ͹碌ɽ뤫ɤĤɤ̤ѤƤ
 * ΤפФʤɡĥ֤Ǥʸɽ
 */
void skkwin_jputchar2
( Display *disp, Window win,
  GC roman_ngc, GC kanji_ngc, GC roman_rgc, GC kanji_rgc,
  int x, int y, int chara, 
  int roman_width, int kanji_width, int font_height, 
  int font_ascent, int flag )
{
  char buffer[ 3 ] ;
  int kanji_flag ;

  if( chara > 0x100 ){
    buffer[ 0 ] = ( chara & 0x07F00 ) >> 8 ;
    buffer[ 1 ] = ( chara & 0x0007F ) ;
    buffer[ 2 ] = '\0' ;
    kanji_flag  = True ;
  } else {
    buffer[ 0 ] = chara ;
    buffer[ 1 ] = '\0' ;
    kanji_flag  = False ;
  }
  if( flag ){
    if( kanji_flag ){
      XDrawString16
	( disp, win, kanji_rgc, x, y, ( XChar2b *)buffer, 1 ) ;
    } else {
      XDrawString
	( disp, win, roman_rgc, x, y, buffer, 1 ) ;
    }
  } else {
    /* ʸɽ*/
    if( kanji_flag ){
      skkwin_jerase
	( disp, win, roman_rgc,
	  x, y, font_ascent, kanji_width, font_height ) ;
      XDrawImageString16
	( disp, win, kanji_ngc, x, y, ( XChar2b *)buffer, 1 ) ;
    } else {
      skkwin_jerase
	( disp, win, roman_rgc,
	  x, y, font_ascent, roman_width, font_height ) ;
      XDrawImageString
	( disp, win, roman_ngc, x, y, buffer, 1 ) ;
    }
  }
  return ;
}

/*
 * ꤵ줿ɥλꤵ줿֤ʸɽؿ
 *----
 * ưԤϤʤΤǡեȤξ󤷤Ϥʤ
 */
void skkwin_jputstring
( Display *disp, Window win, GC roman_gc, GC kanji_gc,
  int x, int y, char *text, int roman_width, int kanji_width )
{
  int kanji_flag = False ;
  char buffer[ 3 ] ;

  buffer[ 2 ] = '\0' ;

  for( ; *text != '\0' ; text ++ ){
    if( ( 0x80 & *text ) && !kanji_flag ){
      kanji_flag = True ;
      buffer[ 0 ] = ( *text ) & 0x7F ;
    } else {
      if( 0x80 & *text ){
	buffer[ 1 ] = 0x7F & ( *text ) ;
	XDrawString16
	  ( disp, win, kanji_gc, x, y, ( XChar2b *)buffer, 1 ) ;
	x += kanji_width ;
	kanji_flag = False ;
      } else {
	buffer[ 0 ] = *text ;
	buffer[ 1 ] = '\0' ;
	XDrawString
	  ( disp, win, roman_gc, x, y, buffer, 1 ) ;
	x += roman_width ;
#if 0
	kanji_flag = False ;
#endif
      }
    }
  }
  return ;
}

/*
 * ʬؿɽطνʤԵǽ̵
 *-----
 * Ϥ minibuffer ѤȤäޤ
 */
void skkwin_jdiffputstring
( Display *disp, Window win, 
  GC roman_ngc, GC kanji_ngc, GC roman_rgc, GC kanji_rgc,
  int x, int y, int width,
  char *text, char *ptext, int roman_width, int kanji_width,
  int font_height, int font_ascent )
{
  int dkana_flag, skana_flag, charas_are_different, diff_flag, chara ;

  charas_are_different = diff_flag = dkana_flag = skana_flag = False ;
  chara = 0 ;

  /* ĤʸӤ롣*/
  while( *text != '\0' && x < width ){
    /* ɤɤɤʤ餽βХܤ*/
    if( 0x80 & *text ){
      dkana_flag = dkana_flag % 2 + 1 ;
    } else {
      dkana_flag = 0 ;
    }
    /* ɽ줿ȽԤ*/
    if( 0x80 & *ptext ){
      skana_flag = skana_flag % 2 + 1 ;
    } else {
      skana_flag = 0 ;
    }
    /* ơ饯ϰۤʤΤǤ礦 */
    if( *ptext != *text || skana_flag != dkana_flag || *ptext == '\0' ){
      charas_are_different = True ;
    } else {
      charas_are_different = False ;
    }
    switch( dkana_flag ){
      /* ɤν*/
    case 0 :
      /* ꤬˲ԤƤޤäƤˤ̾ɽ*/
      /* ǤϤʤơ饯Ӥưۤʤɽ*/
      if( charas_are_different )
	skkwin_jputchar2
	  ( disp, win, roman_ngc, kanji_ngc, roman_rgc, kanji_rgc,
	    x, y, *text, roman_width, kanji_width, font_height,
	    font_ascent, False ) ;
      /* ɽ֤ΰư*/
      x += roman_width ;
      break ;
      /* ɤΰХܤν*/
    case 1 :
      chara = ( unsigned char )*text ;
      /* ä˲ԤƤޤäƤˤԤġ*/
      /* ɤΰХܤʸ󤬰ۤʤäƤ硣*/
      if( charas_are_different )
	diff_flag = True ;
      break ;
      /* ɤХܤν*/
    case 2 :
      chara = ( chara << 8 ) | ( ( unsigned char )*text ) ;
      /* ɤХܤʸ󤬰ۤʤäƤڤӡХ *
       * ܤǰۤʤäƤˤϽľκȤ롣                 */
      if( charas_are_different || diff_flag ){
	skkwin_jputchar2
	  ( disp, win, roman_ngc, kanji_ngc, roman_rgc, kanji_rgc,
	    x, y, chara, roman_width, kanji_width, font_height,
	    font_ascent, False ) ;
	diff_flag = False ;
      }
      /* ɽ֤ΰư*/
      x += kanji_width ;
      break ;
    default :
      dkana_flag = 0 ;
      break ;
    }
    text ++ ;
    if( *ptext != '\0' )
      ptext ++ ;
  }
  /* ̰դޤɽƤΤǾõȤɬ̵*/
  /* ⤷ɽ˻ȤäʬĶɽƤΤǡ*/
  if( x >= width || *ptext == '\0' )
    return ;
  /* 񤭤Ƥʤʬõľ*/
  while( *ptext != '\0' ){
    skkwin_jerase
      ( disp, win, roman_rgc,
	x, y, font_ascent, roman_width, font_height ) ;
    x += roman_width ;
    ptext ++ ;
  }
  return ;
}

/*
 * ɽؿ
 *----
 * int kf : ե饰EUC ɤʤ True ˤʤ롣
 */
void skkinputDrawCursor
( Display *disp, Window win, GC roman_ngc, GC roman_rgc, 
  int x, int y, int font_ascent, int width, int height, int is_focus )
{
  /* ɽ롣*/
  if( is_focus ){
    XFillRectangle
      ( disp, win, roman_ngc,
	x, y - font_ascent + 1, width - 1, height - 1 ) ;
  } else {
    XFillRectangle
      ( disp, win, roman_rgc,
	x, y - font_ascent + 1, width - 1, height - 1 ) ;
    XDrawRectangle
      ( disp, win, roman_ngc,
	x, y - font_ascent + 1, width - 1, height - 2 ) ;
  }
  return ;
}

GC my_CreateGC
( Widget gw, Pixel foreground, Pixel background, XFontStruct *font )
{
  XGCValues	myXGCV ;
  XtGCMask	valuemask ;

  myXGCV.foreground = foreground ;
  myXGCV.background = background ;
  myXGCV.font       = font->fid ;
  valuemask = GCForeground | GCBackground | GCFont ;
  return XtGetGC( gw, valuemask, &myXGCV ) ;
}

/*
 * եȤξȴФΤѤؿ
 */
void getFontInfo
( XFontStruct *fs_kanji, XFontStruct *fs_roman,
  int *ret_kanji_width, int *ret_roman_width,
  int *ret_font_height, int *ret_font_ascent )
{
  int roman_width, roman_ascent, roman_height ;
  int kanji_width, kanji_ascent, kanji_height ;
  int fontwidth_sub1, fontwidth_sub2 ;

  /* եȤξɤ߽ФƤ*/
  roman_width  = fs_roman->max_bounds.width ;
  roman_ascent = fs_roman->ascent ;
  roman_height = roman_ascent + fs_roman->descent ;
  kanji_width  = fs_kanji->max_bounds.width ;
  kanji_ascent = fs_kanji->ascent ;
  kanji_height = kanji_ascent + fs_kanji->descent ;

  fontwidth_sub1 = ( roman_width << 1 ) ;
  fontwidth_sub2 = ( kanji_width >> 1 ) ;
  /* ߤΥեȤ礭δطѤʤΤ⤷ʤ*/
  if( fontwidth_sub1 != kanji_width ){
    /* ѿܤΤ礭 */
    if( fontwidth_sub1 > kanji_width ){
      kanji_width = fontwidth_sub1 ;
    } else {
      /* ѿܤΤϴϾ餷*/
      roman_width = fontwidth_sub2 ;
    }
  }
  *ret_roman_width = roman_width ;
  *ret_kanji_width = kanji_width ;

  *ret_font_height =
    ( ( kanji_height > roman_height )? kanji_height : roman_height ) ;
  *ret_font_ascent =
    ( ( kanji_ascent > roman_ascent )? kanji_ascent : roman_ascent ) ;
  return ;
}

void OTSW_CalcTopPositionOfBuffer
( unsigned char *linetop, int linetop_pos, int cur_pos,
  int client_width, int roman_width, int kanji_width,
  unsigned char **ret_toptext, int *ret_toppos )
{
  unsigned char *text, *toptext ;
  int toppos, pos, x ;
  
  text    = linetop ;
  pos     = linetop_pos ;
  toppos  = linetop_pos ;
  toptext = linetop ;
  x       = 0 ;

  for( ; *text != '\0' ; pos ++, text ++ ){
    if( is_euc_kanji( *text ) ){
      x += kanji_width ;
      if( x >= client_width ){
	toppos  = pos ;
	toptext = text ;
	x = kanji_width ;
      }
      if( pos == cur_pos )
	break ;
      pos ++ ;
      text ++ ;
    } else {
      x += roman_width ;
      if( x >= client_width ){
	toppos  = pos ;
	toptext = text ;
	x = roman_width ;
      }
      if( pos == cur_pos )
	break ;
      /* ԥɤʤ鼡ΰ֤˽롣*/
      if( *text == '\n' ){
	toppos  = pos + 1 ;
	toptext = text + 1 ;
	x = 0 ;
      }
    }
  }
  *ret_toptext = toptext ;
  *ret_toppos  = toppos ;
  return ;
}

/*
 * ȥåץХåեΰ־ιԤɽؿ
 *----
 * դǵ㤭Ȥ()
 */
void OTSW_FullDrawTopBufferTopLine
( Display *disp, Window win,
  GC roman_ngc, GC kanji_ngc, GC roman_rgc, GC kanji_rgc,
  unsigned char *text, int text_pos,
  int roman_width, int kanji_width, int font_ascent, int font_height,
  int width, int bsflag, int cur_pos, int cur_exist, int is_focus )
{
  int x = 0 ;
  int kanji_check, kana_flag, chara = 0, cursor_flag = False ;
  
  kanji_check = kana_flag = False ;

  /* ʤäν*/
  for( ; *text != '\0' && x < width ; text ++, text_pos ++ ){
    /* ɤȽԤ*/
    kanji_check = is_euc_kanji( *text ) ;

    /* ɽʤΤɤȽꤹ롣*/
    if( text_pos == cur_pos && cur_exist ){
      if( !bsflag ||
	 ( kanji_check && ( x + kanji_width ) < width ) ||
	 ( !kanji_check && ( x + roman_width ) < width ) ){
	skkinputDrawCursor
	  ( disp, win, roman_ngc, roman_rgc,
	   x, font_ascent, font_ascent,
	   ( kanji_check )? kanji_width : roman_width,
	   font_height, is_focus ) ;
	cursor_flag = True ;
      }
    }
    /* ɤΰХܤʤΤǤ礦 */
    if( kanji_check && kana_flag == False ){
      kana_flag = True ;
      chara = ( unsigned char )*text ;
      /* ̤αüޤ褷ΤɤȽǤ롣*/
      if( ( x + kanji_width ) >= width && bsflag ){
	skkwin_jputchar
	  ( disp, win, roman_ngc, kanji_ngc, 
	    x, font_ascent, '\\', False ) ;
	skkwin_jputchar
	  ( disp, win, roman_ngc, kanji_ngc,
	    x + roman_width, font_ascent, '\\', False ) ;
	/* ɽʤΤǡԡϤʤλ*/
	return ;
      }
      continue ;
    }
    /* ɤХܤʤΤǤ礦 */
    if( kana_flag ){
      chara = ( chara << 8 ) | ( ( unsigned char )*text ) ;
      if( cursor_flag ){
	if( is_focus ){
	  skkwin_jputchar
	    ( disp, win, roman_rgc, kanji_rgc,
	     x, font_ascent, chara, True ) ;
	} else {
	  skkwin_jputchar
	    ( disp, win, roman_ngc, kanji_ngc,
	     x, font_ascent, chara, True ) ;
	}
	cursor_flag = False ;
      } else {
	skkwin_jputchar
	  ( disp, win, roman_ngc, kanji_ngc,
	   x, font_ascent, chara, False ) ;
      }
      x += kanji_width ;
      kana_flag = False ;
      continue ;
    }
    /* ɤäνǤ*/
    if( ( x + roman_width ) >= width && bsflag ){
      skkwin_jputchar
	( disp, win, roman_ngc, kanji_ngc,
	 x, font_ascent, '\\', False ) ;
      /* ɽʤΤǡԡϤʤλ*/
      return ;
    }
    if( cursor_flag ){
      if( is_focus ){
	skkwin_jputchar
	  ( disp, win, roman_rgc, kanji_rgc,
	   x, font_ascent, *text, True ) ;
      } else {
	skkwin_jputchar
	  ( disp, win, roman_ngc, kanji_ngc,
	   x, font_ascent, *text, True ) ;
      }
      cursor_flag = False ;
    } else {
      skkwin_jputchar
	( disp, win, roman_ngc, kanji_ngc,
	 x, font_ascent, *text, False ) ;
    }
    x += roman_width ;
    /* ԥɤɤˤϡǽ롣*/
    if( *text == '\n' )
      return ;
  }
  /* 뤬ƥȤθ¸ߤ硣*/
  if( cur_exist && text_pos == cur_pos ){
    if( ( !bsflag || ( x + roman_width ) < width ) ){
      skkinputDrawCursor
	( disp, win, roman_ngc, roman_rgc,
	 x, font_ascent, font_ascent,
	 roman_width, font_height, is_focus ) ;
    } else {
      skkwin_jputchar
	( disp, win, roman_ngc, kanji_ngc,
	 x, font_ascent, '\\', False ) ;
    }
  }
  return ;
}


/*
 * cur_line != NULL ʤСΤä꤬ܤǤ뤫֤
 */
int skkinput_GetLineNum
( unsigned char *text, int roman_width, int kanji_width,
  unsigned int width, int cur_pos, int *cur_line )
{
  int num, cur_num, x, y, pos, kana_flag ;
  char *ptr ;

  /* ɽѿν*/
  x = y = pos = kana_flag = cur_num = num = 0 ;
  /* 롼ס*/
  for( ptr = text ; *ptr != '\0' ; ptr ++, pos ++ ){
    /* ɤ򸫤롣*/
    if( 0x80 & *ptr ){
      kana_flag = kana_flag % 2 + 1 ;
    } else {
      kana_flag = 0 ;
    }
    /* ɤν*/
    switch( kana_flag ){
      /* ɤξν*/
    case 0 :
      x += roman_width ;
      if( x >= width ){
	x = roman_width ;
	num ++ ;
      }
      /* ֤򵭲롣*/
      if( pos == cur_pos )
	cur_num = num ;
      if( *ptr == '\n' ){
	x = roman_width ;
	num ++ ;
      }
      break ;
      /* ɤΰХܤν*/
    case 1 :
      x += kanji_width ;
      if( x >= width ){
	x = kanji_width ;
	num ++ ;
      }
      /* ֤򵭲롣*/
      if( pos == cur_pos )
	cur_num = num ;
      break ;
      /* ɤХܤν*/
    case 2 :
      /* ʳΥɤʤ̵롣*/
    default :
      /* ֤򵭲롣*/
      if( pos == cur_pos )
	cur_num = num ;
      break ;
    }
  }

  /* ̤˥ȯƤʤ硣*/
  if( pos <= cur_pos ){
    if( ( x + kanji_width ) > width )
      num ++ ;
    cur_num = num ;
  }

  /* ΰ֤֤Τʡ */
  if( cur_line != NULL )
    *cur_line = cur_num ;
  return num ;
}

/*
 * ɽ٤ΰ礭ʬäƤʸβΰ֤ɽ
 * 뤫ؿ
 */
int skkinput_FindStartLine
( unsigned char *text, int roman_width, int kanji_width,
  int startline, unsigned int width )
{
  int x, kana_flag, pos ;
  char *ptr ;

  /* ɽϹԤƬä顢Ĵ٤ޤǤʤϤƤʸ *
   * ƬǤ褤*/
  if( startline == 0 )
    return 0 ;

  /* ɽѿν*/
  x = pos = kana_flag = 0 ;
  /* 롼ס*/
  for( ptr = text ; *ptr != '\0' ; ptr ++, pos ++ ){
    /* ɤ򸫤롣*/
    if( 0x80 & *ptr ){
      kana_flag = kana_flag % 2 + 1 ;
    } else {
      kana_flag = 0 ;
    }
    /* ɤν*/
    switch( kana_flag ){
      /* ɤξν*/
    case 0 :
      x += roman_width ;
      if( x >= width || *ptr == '\n' ){
	x = roman_width ;
	startline -- ;
	if( startline <= 0 ){
	  /* ԥɤμɽľʤȤʤ顣*/
	  if( *ptr == '\n' )
	    pos ++ ;
	  goto exit_loop ;
	}
      }
      break ;
      /* ɤΰХܤν*/
    case 1 :
      x += kanji_width ;
      if( x >= width ){
	x = kanji_width ;
	startline -- ;
	if( startline <= 0 )
	  goto exit_loop ;
      }
      break ;
      /* ɤХܤν*/
    case 2 :
      break ;
      /* ʳΥɤʤ̵롣*/
    default :
      break ;
    }
  }
exit_loop:
  return pos ;
}

/*
 * Window manager ξ񴹤ؿ
 */
void XChangeWMNormalHints
( Display *disp, Window win, XSizeHints *hints )
{
  XSizeHints sizehints ;
  long supplied ;

  /* Window Manager ˥ҥȤäƤ롣XSetWMNormalHints * 
   * ʬ񴹤ʤ褦ʤΤǡ hints ɤߤȤäƤ麹*
   * ؤȤˡȤʤФʤʤ*/
  XGetWMNormalHints
    ( disp, win, &sizehints, &supplied ) ;
  /*
   * 顢ե饰򸫤ƽȤȤԤ
   */

  /* ɥɽ֤θ򲿽ˤȤ뤫*/
  if( hints->flags & PWinGravity ){
    sizehints.flags |= PWinGravity ;
    sizehints.win_gravity = hints->win_gravity ;
  }
  /* ɥΥ١ꡣ*/
  if( hints->flags & PBaseSize ){
    sizehints.flags |= PBaseSize ;
    sizehints.base_width  = hints->base_width ;
    sizehints.base_height = hints->base_height ;
  }
  /* ɥκǾ礭ꡣ*/
  if( hints->flags & PMinSize ){
    sizehints.flags |= PMinSize ;
    sizehints.min_width  = hints->min_width ;
    sizehints.min_height = hints->min_height ;
  }
  /* ɥκ礭ꡣ*/
  if( hints->flags & PMaxSize ){
    sizehints.flags |= PMaxSize ;
    sizehints.max_width  = hints->max_width ;
    sizehints.max_height = hints->max_height ;
  }
  /* ɥʬ(Ѳ)ꡣ*/
  if( hints->flags & PResizeInc ){
    sizehints.flags |= PResizeInc ;
    sizehints.width_inc  = hints->width_inc ;
    sizehints.height_inc = hints->height_inc ;
  }
  /* ꤹ롣*/
  XSetWMNormalHints( disp, win, &sizehints ) ;
  return ;
}

/*
 * ꤵ줿礭֤ξ XRectangle ¤Τ֤ؿ
 */
void XGetRectangleOfWindow( Display *disp, Window win, XRectangle *area )
{
  Window rootwin ;
  int x, y ;
  unsigned int border_width, depth_size, height, width ;
  
  XGetGeometry
    ( disp, win,
      &rootwin, &x, &y, &width, &height,
      &border_width, &depth_size ) ;
  area->x = ( short )x ;
  area->y = ( short )y ;
  area->width  = ( unsigned short )width ;
  area->height = ( unsigned short )height ;
  return ;
}
