#include <stdio.h>
#include <stdlib.h>
#include <setjmp.h>
#include <signal.h>
#include <sys/types.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/ShellP.h>

#include "commondef.h"
#include "buffers.h"
#include "Kinput.h"
#if defined(SUPPORT_XIMP)
#include "Ximp.h"
#endif
#include "SeparateWin.h"
#include "OverWin.h"
#include "skkkey.h"
#include "config.h"
#include "version.h"

/*
 * main Ѥѿη
 */
struct skkinputOptionDef {
  char *chara ;
  int  function_no ;
  int  need_argument ;
} ;

/*
 * ᥤѤ
 */
enum {
  OPTION_HOST = 0, OPTION_PORT, OPTION_USERDIC, OPTION_BAKDIC,
  OPTION_SKKDIC, OPTION_SKKREC, OPTION_HELP, OPTION_VERSION,
  OPTION_CONFIG,
} ;


/*
 * ץȥ
 */
static int skkinput_checkOptions( int argc, char *argv[] ) ;
static int skkinput_usage( void ) ;
static void skkinput_Quit( void ) ;
static void skkinput_redraw_allskkinputs( void ) ;
static void skkinput_CheckEvent( Display *display, XEvent *xevent ) ;

/*
 * ҶåȤƤФ륳ХåؿΥץȥ
 */
static void setupInputWindow
( Widget gw, caddr_t client, caddr_t caller ) ;
static void closeProtocolServer
( Widget gw, caddr_t client, caddr_t caller ) ;

/*
 * ¾ͤΥˤؿǡmain.c 黲ȤƤΤΥץȥ
 * 
 */
/* skkconfig.c */
extern void initSkkinputDousaketteiVariables( void ) ; 
extern int  skkinput_readConfigFile( char *config_file ) ;
extern int  skkinput_setSkkInputValues( Widget gw ) ;
/* skksvect.c */
extern void initVectorHashTable( void ) ;
/* skkldrec.c */
extern void initHenkanKakuteiHashTable( void ) ;
extern void clearHenkanKakuteiHash( void ) ;
/* skksoc.c */
extern int  skkinput_StartCommunication( char *server_name, int port_num ) ;
extern int  skkinput_CloseCommunication( void ) ;
/* skkldic.c */
extern int  set_localjisyo
( unsigned char *jisyo_path,  unsigned char *jisyobak_path,
  unsigned char *record_path, unsigned char *master_localjisyo ) ;
extern int  close_localjisyo( void ) ;
extern void skkinput_updateLocalJisyo( void ) ;
/* mydispatch.c */
extern int mydispatch_event( Display *disp, XEvent *xevent ) ;

extern void initialize_myerrorhandler( void ) ;
extern void ignore_xerror( void ) ;
extern void regard_xerror( void ) ;
extern int remove_allmyeventhandler( Display *disp, Window src_win ) ;

/*
 * ΥǤѤʤХѿ
 */
/* X Tool Kit  ץꥱ󥳥ƥȡ*/
static XtAppContext app_context ;

static Widget toplevel, kinput_protocol ;
#if defined(SUPPORT_XIMP)
static Widget ximp_protocol ;
#endif

/* X Tool Kit ɬפȤƤ Option ꡣ*/
static XrmOptionDescRec options[] = {
  { "-fk",	"*kanjiFont",	XrmoptionSepArg,	NULL },
  { "-fr",	"*font",	XrmoptionSepArg,	NULL },
  { "-rv",	"*reverseVideo",XrmoptionNoArg,		"TRUE" },
  { "+rv",	"*reverseVideo",XrmoptionNoArg,		"FALSE" },
  { "-fg",	"*foreground",	XrmoptionSepArg,	NULL },
  { "-bg",	"*background",	XrmoptionSepArg,	NULL },
  { "-bd",	"*borderColor",	XrmoptionSepArg,	NULL },
  { "-geometry","*Geometry",	XrmoptionSepArg,	NULL },
  { "-ccsk",	"*compatibleCloseSkkinputKey", XrmoptionNoArg, "TRUE" },
  { "+ccsk",	"*compatibleCloseSkkinputKey", XrmoptionNoArg, "FALSE" },
};

/* skkinput λɬפʽԤѤ longjmp δĶ*/
static jmp_buf skkinputQuitEnv ;

/* ѴФäƤץȥο*/
static int number_of_protocols ;

/* "~/.skkinput" ǥեȤǤե롣*/
static char *skkinput_config_name ;

/*
 * skkinput ΤۤѤ褦ʥХѿ
 */
/* ¾skkinput ɬפȤskkInputWidget ˤɬפȤʤ*/
char *skkserv_host ;
int  skkserv_portnum ;
char *skkinput_local_jisyo_name ;
char *skkinput_backup_jisyo_name ;
char *skk_local_jisyo_name ;
char *skkinput_record_name ;
int  skk_egg_like_newline ;
int  skkinput_chatadaptermode ;
int  skkinput_search_skk_jisyo ;
int  skkinput_keep_record ;
int  skkinput_date_ad ;
int  skkinput_number_style ;
int  skkinput_delete_implies_kakutei ;
int  skkinput_use_numeric_conversion ;
int  skkinput_tab_width ;

int  skkinput_jisyo_dirty ;
int  skkinput_prev_jisyo_dirty ;

unsigned long skkinput_j_count_kakutei ;
unsigned long skkinput_j_count_touroku ;

struct skk_rom_kana_rule *skkinput_rom_kana_rule_list ;

/*
 * ᥤؿ
 *-------
 * ΥåǤ⤦ˤ䤫ˤʤĤꡣ
 */
int main( int argc, char *argv[] )
{
  Display *display ;
  /* XtTranslations trans ; */
  Arg arg[ 20 ] ;
  Cardinal i ;

  /* skkinput ưѿƤ*/
  initSkkinputDousaketteiVariables() ;
  /* ϤޤäǤ롣*/
  skkinput_jisyo_dirty = skkinput_prev_jisyo_dirty = False ;
  /* ѴκݤѤϥåơ֥Ƥ*/
  initVectorHashTable() ;
  /* κݤѤϥåơ֥Ƥ*/
  initHenkanKakuteiHashTable() ;

  /* ץȥб륦åȤؤѿƤ*/
  kinput_protocol = NULL ;
#if defined(SUPPORT_XIMP)
  ximp_protocol = NULL ;
#endif

  /* ޤTool Kit ν롣*/
  toplevel = XtAppInitialize
    ( &app_context, "Skkinput", options, XtNumber(options), &argc, argv,
      NULL, arg, ( Cardinal ) 0);
  initialize_myerrorhandler() ;

  /* ĤäƤ顢å롣 ToolKit ǤϻȤʤ *
   * 뤫顣*/
  skkinput_config_name = DEFAULT_CONFIGFILE ;
  if( argc > 1 ){
    /* ˥ץ򥹥󤷤ơեΥѥ˽ʤ *
     * Ĵ٤롣*/
    if( !skkinput_checkOptions( argc, argv ) ){
      /* ѤƤ񸻤Ʋ롣*/
      XtDestroyApplicationContext
	( XtWidgetToApplicationContext( toplevel ) ) ;
      return 1 ;
    }
  }
  /* config file ɤǤ餦*/
  skkinput_readConfigFile( skkinput_config_name ) ;

  /* ץ꤬ͥˤʤ褦ˡֺǸɤࡣ*/
  /*  prescan ˤäơǤΰåǥ顼֤뤳 *
   * Ϥʤ*/
  skkinput_checkOptions( argc, argv ) ;

  /* socket Ƥ*/
  skkinput_StartCommunication( skkserv_host, skkserv_portnum ) ;
  /* ɽ꼭ξƤ*/
  set_localjisyo
    ( skkinput_local_jisyo_name, skkinput_backup_jisyo_name,
      skkinput_record_name, skk_local_jisyo_name ) ;

  /* ϤȤ褦ˤ롣*/
  i = 0 ;
  XtSetArg( arg[ i ], XtNinput,  True ) ;
  i ++ ;  
  XtSetArg( arg[ i ], XtNwidth,  10 ) ;
  i ++ ;
  XtSetArg( arg[ i ], XtNheight, 10 ) ;
  i ++ ;
  XtSetArg( arg[ i ], XtNmappedWhenManaged, False ) ;
  i ++ ;
  XtSetValues( toplevel, arg, i ) ;

  number_of_protocols = 0 ;
  /* Kinput Protocol Ѥ뤿νԤ*/
  kinput_protocol = XtVaCreateManagedWidget
    ( "kinput2", kinputWidgetClass, toplevel, NULL ) ;
  /* ɬפʥХåä롣*/
  XtAddCallback
    ( kinput_protocol, XtNsetupInputWindowNotify,
     ( XtCallbackProc )setupInputWindow, ( XtPointer )NULL ) ;
  XtAddCallback
    ( kinput_protocol, XtNserverCloseNotify,
     ( XtCallbackProc )closeProtocolServer,
      ( XtPointer )( &kinput_protocol ) ) ;
  number_of_protocols ++ ;

#if defined(SUPPORT_XIMP)
  /* Ximp Protocol Ѥ뤿νԤ*/
  ximp_protocol = XtVaCreateManagedWidget
    ( "ximp", ximpWidgetClass, toplevel, XtNwidth, 1, XtNheight, 1, NULL ) ;
  /* ɬפʥХåä롣*/
  XtAddCallback
    ( ximp_protocol, XtNsetupInputWindowNotify,
     ( XtCallbackProc )setupInputWindow, ( XtPointer )NULL ) ;
  XtAddCallback
    ( ximp_protocol, XtNserverCloseNotify,
     ( XtCallbackProc )closeProtocolServer,
      ( XtPointer )( &ximp_protocol ) ) ;
  number_of_protocols ++ ;
#endif

  /* Widget ޤǤϼΤϤʤΤǡǼΤ *
   * ΤǤ*/
  XtRealizeWidget( toplevel ) ;

  display = XtDisplay( toplevel ) ;

  signal( SIGINT,  ( void * )skkinput_Quit ) ;
  signal( SIGQUIT, ( void * )skkinput_Quit ) ;
  signal( SIGTERM, ( void * )skkinput_Quit ) ;
  signal( SIGPIPE, ( void * )skkinput_Quit ) ;

  if( !setjmp( skkinputQuitEnv ) ){
    XEvent xevent ;
    while( 1 ){
      /* XtAppMainLoop( app_context ) ; */
      XtAppNextEvent( app_context, &xevent ) ;
      skkinput_CheckEvent( display, &xevent ) ;
      XFlush( XtDisplay( toplevel ) ) ;
    }
  }
  signal( SIGINT,  SIG_IGN ) ;
  signal( SIGQUIT, SIG_IGN ) ;
  signal( SIGTERM, SIG_IGN ) ;
  signal( SIGPIPE, SIG_IGN ) ;

  /* ⤷ޤΤä˴롣*/
  if( kinput_protocol != NULL )
    XtDestroyWidget( kinput_protocol ) ;
#if defined(SUPPORT_XIMP)
  if( ximp_protocol != NULL )
    XtDestroyWidget( ximp_protocol ) ;
#endif

  /* ѤƤ񸻤Ʋ롣*/
  XtDestroyApplicationContext
    ( XtWidgetToApplicationContext( toplevel ) ) ;
  /* skkserv Ȥ communication Ĥ롣*/
  skkinput_CloseCommunication() ;
  /* 񤬱ʤä */
  if( skkinput_jisyo_dirty ){
    fprintf( stderr, "Saving Jisyo..." ) ;
    /* ߤޤǤ˳ѴƤ򥻡֤롣*/
    skkinput_updateLocalJisyo() ;
    fprintf( stderr, "done\n" ) ;
  }
  /* malloc Ƥβ*/
  close_localjisyo() ;
  /* ϥå򥯥ꥢ롣*/
  clearHenkanKakuteiHash() ;
  return 0 ;
}

/*
 * ξ֤ѲƤܸФƥ֥ɥ㥹Ȥ
 * 
 *------
 * main -> widget ؤ̿ˤϡXtSetValues ȤΤȻפ
 * ϡ
 */
static void skkinput_redraw_allskkinputs( void )
{
  /* Ѳ롣*/
  if( kinput_protocol != NULL ){
    XtVaSetValues
      ( kinput_protocol, XtNjisyoDirty, skkinput_jisyo_dirty, NULL ) ;
  }
#if defined(SUPPORT_XIMP)
  if( ximp_protocol != NULL ){
    XtVaSetValues
      ( ximp_protocol, XtNjisyoDirty, skkinput_jisyo_dirty, NULL ) ;
  }
#endif
  return ;
}

/*
 * ä褿٥Ȥåؿ
 */
static void skkinput_CheckEvent( Display *disp, XEvent *xevent )
{
#ifdef DEBUG
  fprintf( stderr, "Type(%d), Serial(%ld), Window(%ld)\n", 
	   xevent->type, xevent->xany.serial, xevent->xany.window ) ;
#endif

  /* ֤ޤļʬΤäƤ륦ɥΤɤ줫˴ *
   *         褦ȤƤ롩                                     *
   * ̱  ֤Τ褦Ǥ͡ġ                                     *
   * ե꡼֤Τ褦ǤͤäƤ͡ 󤿲ȤʤʤΡ      */
  if( xevent->type == DestroyNotify ){
    /* ƼץȥΥФ˲餫Υɥ˴줿Ȥ
       Ȥã롣*/ 
    if( kinput_protocol != NULL ){
      XtVaSetValues
	( kinput_protocol, XtNdestroyWindowEvent, xevent, NULL ) ;
    }
#if defined(SUPPORT_XIMP)
    if( ximp_protocol != NULL ){
      XtVaSetValues
	( ximp_protocol, XtNdestroyWindowEvent, xevent, NULL ) ;
    }
#endif
    return ;
  }
  mydispatch_event( disp, xevent ) ;

  /* ѹäˤƤФƽľ׵᤬ɬ *
   * פǤ롣줬¹ԤǤΤϡᥤ*/
  if( skkinput_jisyo_dirty != skkinput_prev_jisyo_dirty ){
    skkinput_redraw_allskkinputs() ;
    skkinput_prev_jisyo_dirty = skkinput_jisyo_dirty ;
  }
  return ;
}

/*
 * skkinput λνԤؿ
 *-----
 * ȤäƤ⡢main ؿνλʬǤǤɡ
 * λˤ application context ʤܤʤΤǡä
 * ؿǤ Selection Owner ǤޤΤǡΤҤä
 * 뤳ȤϾʤȻפΤǤɡ
 */
static void skkinput_Quit( void )
{
  /* ᥤؿνλؤ֡*/
  longjmp( skkinputQuitEnv, 1 ) ;
}

/*
 * ˡ򼨤ؿ
 */
static int skkinput_usage( void )
{
  char **ptr ;
  char *syntaxtable[] = {
    "-\\?           or -help",		  "show this help",
    "-v            or -version",	  "show version",
    "-h <hostname> or -host <hostname>",  "specifies skkserv host",
    "-p <port_num> or -port <port_num>",  "specifies port number",
    "-uj <jisyo>   or -userjisyo <jisyo>","specifies skkinput-local-jisyo",
    "-bj <jisyo>   or -backjisyo <jisyo>","specifies skkinput-local-jisyo\'s backup",
    "-sj <jisyo>   or -skkjisyo <jisyo>", "specifies skk-local-jisyo",
    "-rc <jisyo>   or -record <record>",  "specifies skkinput-record",
    "-fk <kanji fontname>",		  "specifies kanji font",
    "-fr <fontname>",			  "specifies normal text font",
    "-fg <color>",			  "specifies foreground color",
    "-bg <color>",			  "specifies background color",
    "-bd <color>",			  "specifies border color",
    "-geometry <height>x<width>",         "specifies skkinput window geometry",
    "-/+rv",				  "reverse video mode on/off",
    "-/+ccsk",			"<shift>+<space> close skkinput on/off",
    NULL, NULL,
  } ;
  ptr = syntaxtable ;
  while( *ptr != NULL ){
    fprintf( stderr, "%-35s ", *ptr ++ ) ;
    fprintf( stderr, "%s\n", *ptr ++ ) ;
  }
  return 0 ;
}

/*
 * ץΥå򤹤ؿ
 */
static int skkinput_checkOptions( int argc, char *argv[] )
{
  int i, j ;
  struct skkinputOptionDef local_options[] = {
    { "-h",		OPTION_HOST,	True },
    { "-host",		OPTION_HOST,	True },
    { "-p",		OPTION_PORT,	True },
    { "-port",		OPTION_PORT,	True },
    { "-uj",		OPTION_USERDIC,	True },
    { "-userjisyo",	OPTION_USERDIC,	True },
    { "-bj",		OPTION_BAKDIC,	True },
    { "-backjisyo",	OPTION_BAKDIC,	True },
    { "-sj",		OPTION_SKKDIC,	True },
    { "-skkjisyo",	OPTION_SKKDIC,	True },
    { "-rc",		OPTION_SKKREC,	True },
    { "-record",	OPTION_SKKREC,	True },
    { "-config",	OPTION_CONFIG,	True },
    { "-cnf",		OPTION_CONFIG,	True },
    { "-?",		OPTION_HELP,	False },
    { "-help",		OPTION_HELP,	False },
    { "-v",		OPTION_VERSION,	False },
    { "-version",	OPTION_VERSION,	False },
    { NULL,             0,              False },
  } ;
  for( i = 1 ; i < argc ; i ++ ){
    /* ɤ˰פ뤫򸫤롣*/
    for( j = 0 ; local_options[ j ].chara != NULL ; j ++ ){
      if( !strcmp( argv[ i ], local_options[ j ].chara ) )
	break ;
    }
    /* ɤˤפʤä硣*/
    if( local_options[ j ].chara == NULL ){
      fprintf( stderr, "Unknown argument: \"%s\" exists.\n", argv[ i ] ) ;
      goto checkoption_errorreturn ;
    }
    /* ˰ɬפȤƤΤ */
    if( local_options[ j ].need_argument ){
      i ++ ;
      if( i >= argc ){
	fprintf( stderr, "Lack of argument: \"%s\".\n", argv[ i - 1 ] ) ;
	goto checkoption_errorreturn ;
      }
    }
    /* ץν*/
    switch( local_options[ j ].function_no ){
      /* skkserv εƤۥ̾ꤹ롣*/
    case OPTION_HOST :
      skkserv_host = argv[ i ] ;
      break ;
      /* skkserv ̿Ѥݡֹꤹ롣*/
    case OPTION_PORT :
      skkserv_portnum = atoi( argv[ i ] ) ;
      break ;
      /* ɽ꼭̾ꤹ롣*/
    case OPTION_USERDIC :
      skkinput_local_jisyo_name = argv[ i ] ;
      break ;
    case OPTION_BAKDIC :
      skkinput_backup_jisyo_name = argv[ i ] ;
      break ;
      /* إפɽ롣*/
    case OPTION_SKKREC :
      skkinput_record_name = argv[ i ] ;
      break ;
      /* եνߤꤹ롣*/
    case OPTION_CONFIG :
      skkinput_config_name = argv[ i ] ;
      break ;
    case OPTION_HELP :
      goto checkoption_errorreturn ;
      /* Сɽ롣*/
    case OPTION_VERSION :
      fprintf( stderr, "skkinput version %s\n\n", skkinput_version ) ;
      fprintf( stderr, "This is free software. Skkinput can be copied only under the terms of\nthe GNU General Public license. There is NO warranty; not even for \nMERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.\n" ) ;
      return False ;
    default :
      goto checkoption_errorreturn ;
    }
  }
  return True ;
  /* 顼ȯˤϡˡɽƽ롣*/
checkoption_errorreturn:
  skkinput_usage() ;
  return False ;
}

/*
 * ƤǤᥤ󤷤Τʤ Skkinput Widget ФƹԤؿ
 *------
 * ֤㥰Хѿ̵뤷ƥɡġ
 * ֤ޤ󡪡
 * ֤ աġ
 * ֡ĤϡʤȤǤäȤꤷޤ󡪡
 * ֤ĤǤĤġ
 */
static void setupInputWindow
( Widget gw, caddr_t client, caddr_t caller )
{
  skkinput_setSkkInputValues( ( Widget )caller ) ;
  return ;
}

/*
 * Kinput Procotol Server ȤƤεǽߤؿ
 *----------------
 * δؿϥХåȤƲ̤Υå(ĤޤꡢkinputWidget)
 * ƤӽФ뤳Ȥˤʤ롣
 */
static void closeProtocolServer
( Widget gw, caddr_t client, caddr_t caller )
{
  Widget *protocol_widget = ( Widget * )client ;
  /*
   * Ƽ Protocol ΤѰդƤХå˴Ƥ
   */
  XtRemoveAllCallbacks( gw, XtNsetupInputWindowNotify ) ;
  XtRemoveAllCallbacks( gw, XtNserverCloseNotify ) ;
  /*
   * ݡȤƤץȥο򸺤餹̵ʤä顢Ϥ
   * ѴФȤƤεǽϲ̤ʤΤǶλ롣
   */
  number_of_protocols -- ;
  *protocol_widget = NULL ;
  if( number_of_protocols <= 0 ){
    /* ᥤؿνλؤ֡*/
    longjmp( skkinputQuitEnv, 1 ) ;
  }
  return ;
}

